/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;

namespace MiBib
{
	public class Benchmark
	{
		DateTime start;
		DateTime stop;
		TimeSpan tsp;
		
	    public Benchmark()
	    {
	        start = DateTime.Now;
	    }
	
	    public void Stop()
	    {
	    	stop = DateTime.Now;
			tsp = stop - start;
	    }
	    
	    public string Details(bool showMilliseconds)
    	{
    		string str = tsp.Days == 0 ? "" : (tsp.Days + "d ");
    		if (str != "" || tsp.Hours != 0) str += tsp.Hours + "h ";
    		if (str != "" || tsp.Minutes != 0) str += tsp.Minutes + "m ";
    		str += tsp.Seconds + "s";
    		if (showMilliseconds) str += " " + tsp.Milliseconds + "ms";
    		return str;
    	}
	    
	    
	    
	}
}
