/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;
using System.IO;
using System.Text;

namespace MiBib
{
	public class InOut
	{
		/* should look like that,
		 * does not work yet in mono with the constructor StreamWriter(string path, bool append, Encoding encoding),
		 * but with (string path, bool append),
		 * although encoding in the first equals the default
		 * it adds unreadable character at the first position of the first line
		 * 
		public static void ArrayList2File(ArrayList al, string file)
		{
			ArrayList2File(al, file, Encoding.Default);
		}
				// Console.WriteLine("System.Text.Encoding.Default: " + System.Text.Encoding.Default);
				// Console.WriteLine("enc: " + enc);
				// System.Text.Encoding ste = System.Text.Encoding.Default;
				// System.Text.Encoding ste = System.Text.Encoding.ASCII;
		*/
		public static void ArrayList2File(ArrayList al, string file)
		{
			try
			{
				bool bAppend = false;
				StreamWriter sw = new StreamWriter(file, bAppend);
				foreach (string str in al) sw.WriteLine(str);
				sw.Flush(); // 2008-10-14
				sw.Close();
			}
			catch (Exception e) { Console.WriteLine(e.Message); }
		}
		
		
		static ArrayList DirectoryContentSorted(bool getDirectories, bool getSpecialFolders, string dir)
		{
			ArrayList al = new ArrayList();
	    	string[] astr;
			try
			{
				if (getDirectories) astr = Directory.GetDirectories(dir);
				else astr = Directory.GetFiles(dir);
			}
			catch (Exception e)
			{
				Message.Show(e.ToString(), "error:");
				return al;
			}
			foreach (string str in astr) al.Add(MySql3.PathTreatment(str));
			if (getDirectories && !getSpecialFolders && al.Count > 0)
			{
				for (int i = al.Count - 1; i >= 0; i--)
				{
					if (SpecialFolder((string)al[i])) al.Remove(al[i]);
				}
			}
	    	al.Sort();
			return al;
		}
		
		public static ArrayList DirectoryFilesSorted(string dir)
		{
			return DirectoryContentSorted(false, false, dir);
		}
		
		public static ArrayList DirectoryFoldersSorted(bool getSpecialFolders, string dir)
		{
			return DirectoryContentSorted(true, getSpecialFolders, dir);
		}
		
		public static ArrayList File2ArrayList(string file, bool removeGatter)
		{
			return File2ArrayList(file, true, removeGatter);
		}
		
		public static ArrayList File2ArrayList(string file, bool removeEmptyLines, bool removeGatter)
		{
			ArrayList al = new ArrayList();
			FileStream fs;
			StreamReader sr;
			string line;
			try 
			{
				fs = new FileStream(file, FileMode.Open);
				sr = new StreamReader(fs, System.Text.Encoding.Default);
				while ((line = sr.ReadLine()) != null)
				{
					if (line != "")
					{
						if (removeEmptyLines && line == "") { }
						else if (!removeGatter || line.Substring(0, 1) != "#") al.Add(line);
					}
				}
				sr.Close();
				fs.Close();
			}
			catch (Exception e) { Message.Show(e.ToString(), "error"); }
			return al;
		}
		
		public static string FileCopy(string src, string dest)
		{
			try
			{
				if (File.Exists(dest))
				{
					File.SetAttributes(dest, FileAttributes.Normal);
					File.Delete(dest);
				}
				File.Copy(src, dest);
				// Does not work with Linux. Windows I do not know. Would be nicer, though. Works with Nautilus, too.
				//File.SetCreationTime(dest, File.GetCreationTime(src));
				// Does not work with Linux. Windows I do not know. Would be nicer, though. Works with Nautilus, too.
				//File.SetCreationTimeUtc(dest, File.GetCreationTimeUtc(src));
				// Do not know if this works:
				File.SetAttributes(dest, File.GetAttributes(src));
				return "";
			}
			catch (Exception e) { return e.Message; }
		}
		
		public static bool SpecialFolder(string path)
	    {
			string[] astr = new string[]
			{
				"_dateien", // Firefox
				"-Dateien"  // IE
			};
	    	bool b = false;
	    	foreach (string str in astr)
	    	{
	    		if (path.IndexOf(str) != -1) b = true;
	    	}
	        return b;
	    }
		
	}
}
