/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;
using System.IO;

namespace MiBib
{
	public class Ini
	{
		static ArrayList keys;
		static ArrayList values;
		static char sep = '=';

		static void Error(string error, string key, string header)
		{
			Message.Show("key: '" + key + "'\n" + error, "MiBib:Ini." + header);
		}

		public static bool GetBool(string key)
		{
			string val = GetString(key);
			return (val == "1" || val == "true");
		}

		public static int GetInt(string key)
		{
			string str = GetString(key);
			int i = -1;
			try { i = Int32.Parse(str); }
			catch (Exception e) { Error(e.ToString(), key, "GetInt"); }
			return i;
		}

		public static string GetString(string key)
		{
			for (int i = 0; i < keys.Count; i++)
			{
				if ((string)keys[i] == key) return (string)values[i];
			}
			Error("no value found", key, "GetString");
			return "";
		}

		public static string Init(string file)
		{
			string error = "";
			ArrayList al = InOut.File2ArrayList(file, true);
			keys = new ArrayList();
			values = new ArrayList();
			foreach (string str in al)
			{
				if (str != "" && str.Length > 0 && str.Substring(0, 1) != "#")
				{
					string[] astr = str.Split(sep);
					if (astr.Length != 2)
					{
						error += "\nThe entry '" + str + "' from the file '" + file + "' is not correct.";
					}
					else
					{
						keys.Add(astr[0].Trim());
						values.Add(astr[1].Trim());
					}
				}
			}
			return error;
		}

	}
}