/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;
using System.IO;

namespace MiBib
{
	public class Log
	{
		public static void Add(string file, string text)
		{
			Add(file, text, false);
		}
		
		public static void Add(string file, string text, bool dateTimeStamp)
		{
			try
			{
				bool append = true;
				StreamWriter sw = new StreamWriter(file, append, System.Text.Encoding.Default);
				if (dateTimeStamp) sw.WriteLine(DateTime.Now.ToString());
				sw.WriteLine(text);
				sw.Close();
			}
			catch (Exception e) { Message.Show(e.ToString(), "error"); }
		}
		
		public static void Add(string file, string text, bool dateTimeStamp, bool console)
		{
			if (console)
			{
				if (dateTimeStamp) Console.WriteLine(DateTime.Now.ToString());
				Console.WriteLine(text);
			}
			Add(file, text, dateTimeStamp);
		}
		
		
	}
}
