/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MySql.Data.MySqlClient;
using System;
using System.Collections;

namespace MiBib
{
	public class MySql3
	{
		static bool test = false;

		public bool open = false;
		public MySqlCommand cmd;
		MySqlConnection	conn;
		public MySqlDataReader r = null;
		string db;
		string pw;
		string server;
		string user;

		public MySql3(string db, string pw, string server, string user, string query)
		{
			this.db = db;
			this.pw = pw;
			this.server = server;
			this.user = user;

			cmd = new MySqlCommand();
			cmd.CommandText = query;
			if (query != "") ExecReader();
		}

		public void Close()
		{
			try { r.Close(); } catch {}
			try { r = null; } catch {}
			try { conn.Close(); } catch {}
			try { conn = null; } catch {}
		}

		public static string Coll(string db, string pw, string server, string user, ArrayList al)
		{
			string error = "";
			MySql3 m = new MySql3(db, pw, server, user, "");
			m.Connect("Coll");
			if (!m.open) return "db not open";
			try
			{
				m.cmd.Connection = m.conn;
		    	foreach (string str in al)
				{
					m.cmd.CommandText = str;
					m.cmd.ExecuteNonQuery();
				}
		    	m.Close();
			}
			catch (Exception e)
			{
				error = e.Message;
			}
			return error;
		}

		void Connect(string queryTemp)
		{
			try
			{
				conn = new MySqlConnection(
					String.Format("server={0};user id={1};password={2};database={3};pooling=false",
				                  server, user, pw, db));
				conn.Open();
				open = true;
			}
			catch (OverflowException e)
			{
				Message.Show("OverflowException\n\n"
				             + "queryTemp: " + queryTemp + "\n\n"
				             + "e.Message: " + e.Message + "\n\n"
				             + "e: " + e, "MiBib:MySql3.Connect");
			}
			catch (Exception e)
			{
				Message.Show("queryTemp: " + queryTemp + "\n\n"
				             + "e.Message: " + e.Message + "\n\n"
				             + "e: " + e, "MiBib:MySql3.Connect");
			}
		}

		public string ConnectionCheck()
		{
			try
			{
				conn = new MySqlConnection(
					String.Format("server={0};user id={1};password={2};database={3};pooling=false",
				                  server, user, pw, db));
				conn.Open();
				//open = true;
				//try { r.Close(); } catch {}
				//try { r = null; } catch {}
				conn.Close();
				conn = null;
				//open = false;
				return "";
			}
			catch (Exception e) { return "MiBib:MySql3.ConnectionCheck() :: Exception.Message: " + e.Message + "\n  Exception: " + e; }
		}

		public string Exec()
		{
			if (test) Console.WriteLine(cmd);
			string error = "";
			Connect(cmd.CommandText);
			if (!open) return "db not open";
			try
			{
				cmd.Connection = conn;
		    	cmd.ExecuteNonQuery();
		    	Close();
			}
			catch (Exception e)
			{
				error = e.Message;
			}
			return error;
		}

		public static string Exec(string db, string pw, string server, string user, string query)
		{
			string error = "";
			MySql3 m = new MySql3(db, pw, server, user, query); // ..., "");
			// int iAffectedRows = 0;
			// if (!m.open) return "MySql.Exec not open - " + cmd;
			// MySqlCommand mySqlCommand = new MySqlCommand(cmd, m.conn);
			// try { mySqlCommand.ExecuteNonQuery(); }
	        // catch (MySqlException e)
	        // {
	        //     Message.Error(e.Message + "\n" + cmd);
	        //     error += "MySql.Exec " + cmd + " - " + e.Message;
	        // }
			m.Close();
			return error; // iAffectedRows;
		}

		void ExecReader()
		{
			if (test) Console.WriteLine(cmd.CommandText);
			Connect(cmd.CommandText);
			cmd.Connection = conn;
			if (r != null)
			{
				Message.Show("reader not closed", "MiBib:MySql3.ExecReader");
				r = null;
			}
			if (!open)
			{
				Message.Show("ExecuteReader must not be executed w/o a connection being established", "MiBib:MySql3.ExecReader");
				return;
			}
			try { r = cmd.ExecuteReader(); }
			catch (MySqlException e) { Message.Show("MySqlException: " + e.Message + "\n\n" + cmd.CommandText, "MiBib:MySql3.ExecReader"); }
			catch (Exception e) { Message.Show("Exception: " + e.Message + "\n\n" + cmd.CommandText, "MiBib:MySql3.ExecReader"); }
		}


		public static int Id(string db, string pw, string server, string user,
		                     string table, string column, string search)
		{
			int id = 0;
			MySql3 m = new MySql3(db, pw, server, user, "SELECT id FROM " + table + " WHERE " + column + "=\"" + search + "\"");
			if (!m.open) return -1;
			if (m.r.Read()) id = (int)m.r["id"];
			m.Close();
			return id;
		}

		public static string Id2Text(string db, string pw, string server, string user,
		                             string table, string column, int id)
		{
			string text = "";
			MySql3 m = new MySql3(db, pw, server, user, "SELECT " + column + " FROM " + table + " WHERE id=" + id);
			if (!m.open) return "";
			if (m.r.Read()) text = m.r[column].ToString();
			m.Close();
			return text;
		}

		public static int Max(string db, string pw, string server, string user,
		                      string table, string column)
		{
			string query = "SELECT MAX(" + column + ") FROM " + table;
			MySql3 m = new MySql3(db, pw, server, user, query);
			if (!m.open) return -1;
			int i = 0;
			if (m.r.Read())
			{
				if (m.r[0].ToString() == "") i = 0;
				else
				{
					try { i = (int)m.r[0]; }
					catch (Exception e) { Message.Show("m.r[0]: " + m.r[0] + "\n\n" + e, "MiBib:MySqlB.Max"); }
				}
			}
			m.Close();
			return i;
		}

		public static string PathTreatment(string str)
		{
			return str.Replace('\\', '/');
		}

		public static int Results(string db, string pw, string server, string user, string cmd)
		{
			int i = 0;
			MySql3 m = new MySql3(db, pw, server, user, cmd);
			if (!m.open) return -1;
			while (m.r.Read()) i++;
			m.Close();
			return i;
		}
	}
}

