/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;
using System.Diagnostics;

namespace MiBib
{
	public class MySqlCollArray
	{
		ArrayList al = new ArrayList();
		public TimeSpan tsp;
		
		public MySqlCollArray() { }
		
		public void Add(string str)
		{
			al.Add(str);
		}
		
		public void Execute(string db, string pw, string server, string user)
		{
			Console.WriteLine("");
			DateTime dtStart = DateTime.Now;
			string error = MySql3.Coll(db, pw, server, user, al);
			tsp = DateTime.Now - dtStart;
			if (error != "") Console.WriteLine("FAILURE: " + error);
			else Console.WriteLine(Math.Floor(tsp.TotalMinutes) + " min " + tsp.Seconds + " sec for " + al.Count + " queries");
		}
		
		public void ToConsole()
		{
			foreach (string str in al) Console.WriteLine(str);
		}
		
		public void ToFile(string file)
		{
			InOut.ArrayList2File(al, file);
		}
		
	}
	
}

/* Benchmarks incl. updating random
  
                             read    source
  Collections ArrayList File min:sec min:sec SET VALUES
       1          ja     ja    3:06    2:38   1     0
       1         nein    ja    2:24    2:32   1     0
       5         nein    ja    2:31    2:16   1     0
  
  
  
  
 */
