/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.IO;
using System.Collections;
using System.Diagnostics;

namespace MiBib
{
	public class MySqlCollFile
	{
		int count = 0;
		StreamWriter sw;
		string file;
		public TimeSpan tsp;
		
		public MySqlCollFile(string file)
		{
			this.file = file;
			try
			{
				bool bAppend = false;
				sw = new StreamWriter(file, bAppend, System.Text.Encoding.Default);
			}
			catch (Exception e) { Console.WriteLine("MySqlCollection.CreateFile: " + e.Message); }
		}
		
		public void Add(string str)
		{
			count++;
			try { sw.WriteLine(str); }
			catch (Exception e) { Console.WriteLine("MySqlCollection.Add: " + e.Message); }
		}
		
		public void CloseFile()
		{
			try { sw.Close(); }
			catch (Exception e) { Console.WriteLine("MySqlCollection.CloseFile: " + e.Message); }
		}
		
		public void ExecuteFile(string mysql, string mysql_exe, string mysql_user)
		{
			DateTime dtStart = DateTime.Now;
			try
			{
				Console.WriteLine("");
				Console.WriteLine("SOURCE " + file);
				string cmd = mysql_exe + " -s -u" + mysql_user + " -p" + mysql + " -Dmv -e\"SOURCE " + file + "\"";
				Console.WriteLine(cmd);
				Process p = Process.Start(cmd);
    			while (!p.HasExited) p.WaitForExit(1000);
    			
    			tsp = DateTime.Now - dtStart;
    			Console.WriteLine(Math.Floor(tsp.TotalMinutes) + " min " + tsp.Seconds + " sec for " + count + " queries");    			
			}
			catch (Exception e)
			{
				Console.WriteLine("FAILURE: " + e.Message);
			}
    	
		}
		
		public void Show()
		{
			Process.Start(file);
		}
		
	}
	
}

/* Benchmarks incl. updating random
  
                             read    source
  Collections ArrayList File min:sec min:sec SET VALUES
       1          ja     ja    3:06    2:38   1     0
       1         nein    ja    2:24    2:32   1     0
       5         nein    ja    2:31    2:16   1     0
  
  
  
  
 */
