/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MySql.Data.MySqlClient;
using System;
using System.Collections;

namespace MiBib
{
	public class MySqlOc
	{
		static bool test = false;

		int retries = 0;
		int retries_max = 3;
		public MySqlCommand cmd;
		MySqlConnection	conn;
		public MySqlDataReader r = null;
		public string error = "";
		string db;
		string pw;
		string server;
		string user;

		public MySqlOc(string db, string pw, string server, string user)
		{
			this.db = db;
			this.pw = pw;
			this.server = server;
			this.user = user;
		}

		public void ChangeDatabase(string db_temp)
		{
			conn.ChangeDatabase(db_temp);
		}

		public void ChangeDatabaseBack()
		{
			conn.ChangeDatabase(db);
		}

		public void CloseReader()
		{
			try { r.Close(); } catch {}
			try { r = null; } catch {}
		}

		public void CloseConn()
		{
			try { conn.Close(); } catch {}
			try { conn = null; } catch {}
		}

		void Connect()
		{
			try
			{
				cmd = new MySqlCommand();
				conn = new MySqlConnection(String.Format("server={0};user id={1};password={2};database={3};pooling=false", server, user, pw, db));
				conn.Open();
				cmd.Connection = conn;
			}
			catch (OverflowException e)
			{
				Message.Show("OverflowException\n\n" + "e.Message: " + e.Message + "\n\n" + "e: " + e, "MiBib:MySqlOc.Connect");
			}
			catch (Exception e)
			{
				Message.Show("e.Message: " + e.Message + "\n\n" + "e: " + e, "MiBib:MySqlOc.Connect");
			}
		}

		void Error(Exception e, string query) { Message.Show(e + "\n" + query, "MiBib.MySqlOc"); }

		public int Exec(string query)
		{
			error = "";
			if (test) Console.WriteLine(query);
			int affected_rows = 0;
			try
			{
				cmd.CommandText = query;
				affected_rows = cmd.ExecuteNonQuery();
				retries = 0;
			}
			catch (NullReferenceException e) { ExecRetry(false, e, query); }
			catch (Exception e) { Error(e, query); error += e.ToString() + "\n"; }
			return affected_rows;
		}

		public void ExecReader(string query)
		{
			error = "";
			if (test) Console.WriteLine(query);
			try
			{
				cmd.CommandText = query;
				r = cmd.ExecuteReader();
				retries = 0;
			}
			catch (NullReferenceException e) { ExecRetry(true, e, query); }
			catch (Exception e) { Error(e, query); error += e.ToString() + "\n"; }
		}

		void ExecRetry(bool reader, Exception e, string query)
		{
			retries++;
			if (retries < retries_max)
			{
				Connect();
				if (reader) ExecReader(query); else Exec(query);
			}
			else
			{
				Error(e, query + "\nretries: " + retries_max);
				error += query + "\nretries: " + retries_max + e.ToString() + "\n";
			}
		}

	}
}



