/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using Gtk;

namespace MiBibGtk
{
	public class DialogForm : Dialog
	{
		public static bool YesNo(Fenster f, string title, string text)
		{
			DialogForm d = new DialogForm(f, title, text, ResponseType.Yes, ResponseType.No);
	   		bool ok = d.ok;
	   		d.Destroy();
	   		return ok;
		}
		
		internal bool ok = false;
		
	    internal DialogForm(Window win, string title, string text, ResponseType rt1, ResponseType rt2) : base(title, win, Gtk.DialogFlags.DestroyWithParent)
	    {
	    	Label label = new Label(text);
	    	this.HasSeparator = false;
	    	this.Modal = true;
	    	this.VBox.Add(label);
	        label.Show();
	        this.AddButton(LabelText(rt1), rt1);
	        this.AddButton(LabelText(rt2), rt2);
	        this.Response += new ResponseHandler(This_Response);
	        this.Run();
	    }
	    
	    public static string LabelText(ResponseType rt)
	    {
	    	if (rt == ResponseType.Cancel) return "cancel";
	    	if (rt == ResponseType.No) return "no";
	    	if (rt == ResponseType.Ok) return "ok";
	    	if (rt == ResponseType.Yes) return "yes";
	    	return "error";
	    }
	    
	    void This_Response(object o, ResponseArgs args)
	    {
	    	if (   args.ResponseId == ResponseType.Ok 
	    	    || args.ResponseId == ResponseType.Yes) ok = true;
	    }
	
	}
}
