/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using MiBib;
using System;
using System.Collections;

namespace MiBibGtk
{
	public class Fenster : Gtk.Window
	{
		//internal void this_event(object o, ConfigureEventArgs args)
		//{
		//	Console.WriteLine("Fenster");
		//}
		
		IniMini im;
		string saveOnExit = "";
		
		public Fenster(string title, string icon) : base(title)
		{
			//this.ConfigureEvent += new ConfigureEventHandler(this_event);
			this.DeleteEvent += new DeleteEventHandler(This_Delete);
			
			try { this.Icon = new Gdk.Pixbuf(GetType().Assembly.GetManifestResourceStream(icon)); } catch { }
			
			//this.KeyPressEvent += new KeyPressEventHandler(Key_Pressed);
			//this.SetPosition(WindowPosition.Center);
			//this.Fullscreen();
			//this.Maximize();
			//this.SetDefaultSize(900, 700);
			//this.SetPosition(WindowPosition.Center);
			//this.Move(0, 0);
			//this.Focus = guiWidget.sc.ntrSearch;
		}
		
		//void Key_Pressed(object o, KeyPressEventArgs args)
		//{
		//	Message("key value: " + args.Event.KeyValue);
		//}
		
		public void cc() { Console.WriteLine("CursorOff"); GdkWindow.Cursor = null; Display.Sync(); }
		public void cw() { Console.WriteLine("CursorOn"); GdkWindow.Cursor = new Cursor(CursorType.Watch); Display.Sync(); }

		public string AppearanceFromFile(string file)
		{
			this.saveOnExit = file;
			string error = "";
			im = new IniMini(saveOnExit);
			error += im.Load();
			
			try
			{
				this.Move(Int32.Parse((string)im.val[0]), Int32.Parse((string)im.val[1]));
				this.SetDefaultSize(Int32.Parse((string)im.val[2]), Int32.Parse((string)im.val[3]));
				//if (Ini.GetBool("StartMaximized")) this.Maximize();
				//if (Ini.GetBool("StartWithFullscreen")) this.Fullscreen();
				//if (Ini.GetBool("WindowPositionCenter")) this.SetPosition(WindowPosition.Center);
				return "";
			}
			catch (Exception e) { return e.Message; }
		}
		
		public void Error(string message)
		{
			Message(MessageType.Error, message);
		}
		
		public void Message(string message)
		{
			Message(MessageType.Info, message);
			// MessageType.Error
			// MessageType.Info
			// MessageType.Question
			// MessageType.Warning
		}
		
		public void Message(string message, Exception e)
		{
			Error(message + "\nexception=" + e);//, "exception");
		}
		
		
		public void Message(MessageType mt, string message)
		{
			// !!! message = Peculiar.Substitute(message);
			using(MessageDialog md = new MessageDialog(
				this, DialogFlags.DestroyWithParent, mt, ButtonsType.Close,
				"{0}", message)) 
			{
				md.Run();
				md.Hide();
			}
		}
		
		public void This_Delete(object o, DeleteEventArgs args)
		{
			if (saveOnExit != "")
			{
				int left, top, width, height;
				this.GetPosition(out left, out top);
				this.GetSize(out width, out height);
				Console.WriteLine("pos: " + left + ", " + top);
				Console.WriteLine("size: " + width + ", " + height);
				ArrayList al = new ArrayList();
				al.Add(""+left);
				al.Add(""+top);
				al.Add(""+width);
				al.Add(""+height);
				im.Save(al);
				
			}
			this.Hide();
			this.Destroy();
			if (args != null) args.RetVal = true;
			Application.Quit();
		}
		
		
	}
}
