/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBibGtk;
using System;
using System.Collections;
using System.IO;

class Explorer : ScrolledWindow
{
	bool bSource;
	internal Button browse;
    CheckButton checkBoxAll = new CheckButton("all");
	public CheckButton[] aCheckButton;
	Explorer explorerSource;
	//int x = Mvar.abstand;
    //int y = Mvar.abstand;
    VBox panel = new VBox();
    internal Entry textBox = new Entry();
    
    VBox cnt = new VBox();
    
    public Explorer(bool bSource)
    {
    	this.bSource = bSource;
    	
        Steuerung();
    }
    
    public Explorer(bool bSource, Explorer explorerSource)
    {
    	this.bSource = bSource;
    	this.explorerSource = explorerSource;
    	
        Steuerung();
    }
    
    public string Folder { get { return textBox.Text; } }
    
	void All_CheckedChanged(object o, EventArgs ea)
	{
		try
		{
			for (int i = 0; i < aCheckButton.Length; i++)
			{
				aCheckButton[i].Active = checkBoxAll.Active;
			}
		}
		catch
		{
			// Es ist kein Laufwerk ausgewählt
			checkBoxAll.Active = false;
		}
	}
    
	void Button_Click(object o, EventArgs ea)
	{
		string path = Dialogs.GetFolder("Choose " + (bSource ? "source" : "target"), MainForm.mf, true);

		Console.WriteLine("path='" + path + "'");
		
		if (path == "") return;
		
		//FolderBrowserDialog folderBrowserDialog = new FolderBrowserDialog();
		// folderBrowserDialog.RootFolder = Environment.SpecialFolder.DesktopDirectory;
		//folderBrowserDialog.SelectedPath = "U:\\PUNK-Test";
		//folderBrowserDialog.Description = (bSource ? "Quelle" : "Ziel") + " wählen";
		//folderBrowserDialog.ShowNewFolderButton = true;
		//DialogResult dialogResult = folderBrowserDialog.ShowDialog();
		//if (dialogResult != DialogResult.OK) return;
		
		textBox.Text = path;//folderBrowserDialog.SelectedPath;
		
    	panel.Dispose();
    	string[] astr = new string[0];
    	try
    	{
    		astr = Directory.GetDirectories(Folder);
    	}
    	catch (IOException)
    	{
    		textBox.Text = string.Empty;
    		return;
    	}
    	
    	HBox pad = new HBox();
    	cnt.PackStart(pad, false, false, Var.padding);
    	panel = new VBox();
    	pad.PackStart(panel, false, false, Var.padding);
    	
    	ArrayList arrayList = new ArrayList();
    	foreach (string str in astr)
    	{
    		if (   System.IO.Path.GetFileName(str) != "Recycled"
    		    && System.IO.Path.GetFileName(str) != "RECYCLER"
    		    && System.IO.Path.GetFileName(str) != "System Volume Information"
    			)
    		{
    			arrayList.Add(System.IO.Path.GetFileName(str));
    		}
    	}
    	arrayList.Sort();
    	aCheckButton = new CheckButton[arrayList.Count];//iFolder];
    	for (int i = 0; i < arrayList.Count; i++)
    	{
    		aCheckButton[i] = new CheckButton((string)arrayList[i]);
    		//aCheckButton[i].Enabled = bSource;
    		//aCheckButton[i].Size = new Size(panel.ClientSize.Width - 2 * Mvar.abstand - SystemInfo.Name2Int("VerticalScrollBarWidth"), 20);
    		//aCheckButton[i].Location = new Point(Mvar.abstand, Mvar.abstand + i * (aCheckButton[i].Height + Mvar.abstand));
    		panel.PackStart(aCheckButton[i], false, false, Var.padding / 2);
    		
    		if (!bSource && explorerSource.aCheckButton != null)
    		{
    			foreach (CheckButton checkBox in explorerSource.aCheckButton)
    			{
    				if (checkBox.Label == (string)arrayList[i]) // .Text ??? // todo to check
    				{
    					checkBox.Active = true;
    					aCheckButton[i].Active = true;
    				}
    			}
    		}
    	}
    	this.ShowAll();
    }
    
    void Steuerung()
    {
    	this.AddWithViewport(cnt);
    	
    	HBox b1 = new HBox();
    	cnt.PackStart(b1, false, false, Var.padding);
    	
    	checkBoxAll.Toggled += new EventHandler(All_CheckedChanged);
    	//checkBoxAll.Enabled = bSource;
    	//checkBoxAll.TextAlign = ContentAlignment.MiddleLeft;
    	b1.PackStart(checkBoxAll, false, false, Var.padding);
    	
    	browse = new Button(bSource ? "Source" : "Target");
    	browse.Clicked += new EventHandler(Button_Click);
    	b1.PackStart(browse, false, false, Var.padding);
    	
    	//b1.PackStart(new Label(bSource ? "Source" : "Target"), false, false, Var.padding);
    	
    	// !!! textBox.ReadOnly = true; // todo
    	b1.PackStart(textBox, true, true, Var.padding);
    }
}
