/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBib;
using MiBibGtk;
using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;

class ImageForm : Fenster
{
	bool check = false; // true does not copy, but only show the paths
	
	ArrayList arrayListError = new ArrayList();
	ArrayList arrayListCopyFile = new ArrayList();
	ArrayList arrayListCopyFolder = new ArrayList();
	ArrayList arrayListCopyMainFolder = new ArrayList();
	ArrayList arrayListDeleteFile = new ArrayList();
	ArrayList arrayListDeleteFolder = new ArrayList();
	bool bCanceled;
	public bool bOk = false;
	bool bTest;
	CheckButton checkBox = new CheckButton();
	Explorer explorer1;
	Explorer explorer2;
	Label superviseAction = new Label();
	//Label superviseSize = new Label();
	// ListBox listBox = new ListBox();
	static double limit1 =   10 * Mvar.mb;
	static double limit2 =  100 * Mvar.mb;
	static double limit3 = 1000 * Mvar.mb;
	SizeSorter sizeSorter;
	static string SizeFormatBlank = "  ";
	
	string file = "alldat" + System.IO.Path.DirectorySeparatorChar + "Backup-Log.txt";
	
	public ImageForm(bool bTest, Explorer explorer1, Explorer explorer2) : base ("Image from \"" + explorer1.Folder + "\" to \"" + explorer2.Folder + "\"", Var.icon)
    {
    	this.bTest = bTest;
        this.explorer1 = explorer1;
		this.explorer2 = explorer2;
		
		if (Check())
		{
			bOk = true;
			Steuerung();
				
			this.SetDefaultSize(Var.width, Var.height);
	    	this.SetPosition(WindowPosition.Center);
	    	
			//this.Closing += new CancelEventHandler(This_Closing);
			// ACHTUNG: GIBT ES SCHON IN FENSTER
			this.DeleteEvent += new DeleteEventHandler(This_DeleteEvent_Here);
			this.ShowAll();
		}
    }
    
    void Add(string str)
	{
    	//if (!checkBox.Active) return;
    	if (checkBox.Active)
    	{
    		superviseAction.Text = str;
    		this.ShowAll();
    	}
		//listBox.Items.Add(str);
		//listBox.SelectedIndex = listBox.Items.Count - 1;
		Log.Add(file, str, false, true);
	}
	
    void AddBox(string str)
    {
    	str = "# " + str + " #";
    	int num = str.Length;
    	string ch = "";
    	for (int i = 0; i < num; i++) ch += "#";
    	Add(ch);
    	Add(str);
    	Add(ch);
    	Add("");
    }
    
    void Button_Click(object o, EventArgs ea)
    {
    	Button button = (Button)o;
    	if (button.Name == "Cancel")
    	{
    		bCanceled = true;
    		return;
    	}
    	try { File.Delete(file); } catch { }
		if (button.Name == "Start") 
    	{
    		bTest = false;
    		CreateImage();
    	}
    	else if (button.Name == "Test") 
    	{
    		bTest = true;
    		Start();
    	}
		ShowInfos();
    }
    
	bool Check()
    {
		// does file z.B. {backup} exist in Partition-Root or Folder
		
		// do the selected folders exist ?, sonst complete copy ?
		
		return true;
    }
	
	void CheckCurrent(string strDir)
	{
		if (bCanceled) return;
		if (!Directory.Exists(strDir))
		{
			arrayListError.Add("The folder \"" + strDir + "\" cannot be opened.");
			return;
		}
		
		string[] astrFiles = Directory.GetFiles(strDir);
		foreach (string strSource in astrFiles)
		{
			string strDest = GetDest(strSource);
			if (!File.Exists(strDest))
			{
				arrayListCopyFile.Add(strSource);
				double size = new FileInfo(strSource).Length;
				string type = "    new file";
				Add(SizeFormat(size) + type + ": " + strSource);
				sizeSorter.Add(size, strSource, type);
			}
			else
			{
				DateTime dateTimeDest = File.GetLastWriteTime(strDest);
				DateTime dateTimeSource = File.GetLastWriteTime(strSource);
				//if (dateTimeDest != dateTimeSource)
				if (dateTimeDest < dateTimeSource)
				{
					arrayListCopyFile.Add(strSource);
					double size = new FileInfo(strSource).Length;
					string type = "updated file";
					Add(SizeFormat(size) + type + ": " + strSource);
					sizeSorter.Add(size, strSource, type);
				}
			}
		}
		
		string[] astrDir = Directory.GetDirectories(strDir);
		foreach (string strSource in astrDir)
		{
			string strDest = GetDest(strSource);
			if (!Directory.Exists(strDest))
			{
				arrayListCopyFolder.Add(strSource);
				double size = SizeDir(strSource);
				string type = "  new folder";
				Add(SizeFormat(size) + type + ": " + strSource);
				sizeSorter.Add(size, strSource, type);
			}
			else
			{
				CheckCurrent(strSource);
			}
		}
	}
	
	bool CheckMain(string strDir)
	{
		if (bCanceled) return false;
		if (!Directory.Exists(strDir))
		{
			string strSource = GetSource(strDir);
			arrayListCopyMainFolder.Add(strSource);
			arrayListCopyFolder.Add(strSource);
			Add("ATTENTION: The main folder \"" + strDir + "\" does not exist yet and would be copied entirely.");
			return false;
		}
		return true;
	}
	
	void CheckOld(string strDir)
	{
		if (bCanceled) return;
		if (!Directory.Exists(strDir))
		{
			arrayListError.Add("The folder \"" + strDir + "\" cannot be opened.");
			return;
		}
		
		string[] astrFiles;
		try
		{
			astrFiles = Directory.GetFiles(strDir);
		}
		catch (System.UnauthorizedAccessException e)
		{
			this.arrayListError.Add(e.Message);
			return;
		}
		foreach (string strDest in astrFiles)
		{
			string strSource = GetSource(strDest);
			if (!File.Exists(strSource))
			{
				arrayListDeleteFile.Add(strDest);
				double size = new FileInfo(strDest).Length;
				string type = "    old file";
				Add(SizeFormat(size) + type + ": " + strDest);
				sizeSorter.Add(size, strDest, type);
			}
		}
		
		string[] astrDir = Directory.GetDirectories(strDir);
		foreach (string strDest in astrDir)
		{
			string strSource = GetSource(strDest);
			if (!Directory.Exists(strSource))
			{
				arrayListDeleteFolder.Add(strDest);
				double size = SizeDir(strDest);
				string type = "  old folder";
				Add(SizeFormat(size) + type + ": " + strDest);
				sizeSorter.Add(size, strDest, type);
			}
			else
			{
				CheckOld(strDest);
			}
		}
	}
	
	void Copy()
	{
		if (bCanceled) return;
		foreach (object o in arrayListCopyFile)
		{
			string strSource = (string)o;
			string strDest = GetDest(strSource);
			try
			{
				Add("    Copy file: " + strSource);
				if (check)
				{
					Add("src: " + strSource);
					Add("dst: " + strDest);
				}
				else
				{
					//if (File.Exists(strDest))
					//{
						//File.SetAttributes(strDest, FileAttributes.Normal);
						//File.Delete(strDest);
					//}
					// File.Copy(strSource, strDest);
					
					string error = InOut.FileCopy(strSource, strDest);
					
					if (error != "") arrayListError.Add(error);
				}
			}
			catch (Exception e)
			{
				arrayListError.Add(e.Message);
			}
		}
		foreach (object o in arrayListCopyFolder)
		{
			string strSource = (string)o;
			string strDest = GetDest(strSource);
			Add("  Copy folder: " + strSource);
			if (!check)
			{
				if (!Dateien.DirectoryCopy(strSource, strDest))
				{
					arrayListError.Add("The folder \"" + strSource + "\" could not be copied.");
				}
			}
		}
	}
	
	void CreateImage()
	{
		int foldersToBeCopied = arrayListCopyFolder.Count - arrayListCopyMainFolder.Count;
		string message = "Creating the image from \"" 
		        + explorer1.Folder + "\" to \"" 
		        + explorer2.Folder + "\" would:\n\n"
				+ "copy " + arrayListCopyMainFolder.Count + " main folder" + (arrayListCopyMainFolder.Count == 1 ? "" : "s") + "\n"
				+ "delete " + arrayListDeleteFolder.Count + " folder" + (arrayListDeleteFolder.Count == 1 ? "" : "s") + "\n"
				+ "delete " + arrayListDeleteFile.Count + " file" + (arrayListDeleteFile.Count == 1 ? "" : "s") + "\n"
				+ "copy " + foldersToBeCopied + " folder" + (foldersToBeCopied == 1 ? "" : "s") + "\n"
				+ "copy " + arrayListCopyFile.Count + " file" + (arrayListCopyFile.Count == 1 ? "" : "s") + "\n"
				+ "\nShall that happen?";
		
		if (!DialogForm.YesNo(this, "Proceed?", message)) return;
		
		DateTime dateTimeStart = DateTime.Now;
		this.cw();
		bCanceled = false;
		
		AddBox("Image from " + dateTimeStart.ToShortDateString() + String.Format(" at {0:D2}:{1:D2}:{2:D2}", dateTimeStart.Hour, dateTimeStart.Minute, dateTimeStart.Second));
		AddBox("Creating the image (phase 1): Deleting old folders and files");
		
		DeleteOld();
		
		Add("");
		AddBox("Creating the image (phase 2): Copying new and updated folders and files");
		
		Copy();
		
		Add("");
		AddBox("Errors:" + (arrayListError.Count == 0 ? " none" : ""));
		foreach (object o in arrayListError)
		{
			Add((string)o);
		}
		Add("");
		
		DateTime dateTimeStop = DateTime.Now;
		TimeSpan timeSpan = dateTimeStop - dateTimeStart;
		AddBox((bCanceled ? "Canceled" : "Completed")
			+ String.Format(" at {0:D2}:{1:D2}:{2:D2}", dateTimeStop.Hour, dateTimeStop.Minute, dateTimeStop.Second) 
			+ String.Format(" (duration: {0:D2}:{1:D2}:{2:D2})", timeSpan.Hours, timeSpan.Minutes, timeSpan.Seconds));
		bCanceled = true;
		this.cc();
	}
	
	void DeleteOld()
	{
		if (bCanceled) return;
		foreach (object o in arrayListDeleteFile)
		{
			Add("  Delete file: " + o);
			if (!check)
				{
				try
				{
					File.SetAttributes((string)o, FileAttributes.Normal);
					File.Delete((string)o);
					
				}
				catch (Exception e)
				{
					arrayListError.Add(e.Message);
				}
			}
		}
		foreach (object o in arrayListDeleteFolder)
		{
			Add("Delete folder: " + o);
			if (!check) Dateien.DirectoryDelete((string)o);
		}
	}
	
	string GetDest(string str)
	{
		return explorer2.Folder + str.Substring(explorer1.Folder.Length);		
	}
	string GetSource(string str)
	{
		return explorer1.Folder + str.Substring(explorer2.Folder.Length);		
	}
	
	double SizeDir(string dir)
	{
		double size = 0;
		string str = "";
		try
		{
			string[] astr = Directory.GetDirectories(dir);
			for (int i = 0; i < astr.Length; i++)
			{
				str = astr[i];
				Console.WriteLine(str);
				size += SizeDir(str);
			}
			astr = Directory.GetFiles(dir);
			for (int i = 0; i < astr.Length; i++)
			{
				str = astr[i];
				Console.WriteLine(str);
				size += new FileInfo(str).Length;
			}
		} catch (Exception e) { Message(MessageType.Error, "SizeDir\n\n" + e.Message + "\n\n" + str); }
		return size;
	}
	
	string SizeFormat(double size)
	{
		if (size < limit1) return "        " + SizeFormatBlank;
		if (size < limit2) return "   " + String.Format("{0:F0} MB", size/Mvar.mb) + SizeFormatBlank;
		if (size < limit3) return "* " + String.Format("{0:F0} MB", size/Mvar.mb) + SizeFormatBlank;
		return "!   " + String.Format("{0:F1} GB", size/Mvar.gb) + SizeFormatBlank;
	}
	
	public void Start()
	{
		this.cw();
		bCanceled = false;
		DateTime dateTimeStart = DateTime.Now;
		sizeSorter = new SizeSorter();
		arrayListError.Clear();
		arrayListCopyFile.Clear();
		arrayListCopyFolder.Clear();
		arrayListCopyMainFolder.Clear();
		arrayListDeleteFile.Clear();
		arrayListDeleteFolder.Clear();
		try { File.Delete(file); } catch { }
		AddBox("Check from " + dateTimeStart.ToShortDateString() + String.Format(" at {0:D2}:{1:D2}:{2:D2}", dateTimeStart.Hour, dateTimeStart.Minute, dateTimeStart.Second));
		foreach (CheckButton checkBox in explorer1.aCheckButton)
		{
			if (checkBox.Active)
			{
				AddBox("Start: " + explorer1.Folder + checkBox.Label);
				if (!bCanceled)
				{
					Add("### Phase 1 ### Checking for the existance of the main folder \"" 
					    + explorer2.Folder + checkBox.Label + "\"");
					Add("");
					bool b = CheckMain(explorer2.Folder + checkBox.Label);
					if (b)
					{
						Add("");
						Add("### Phase 2 ### Looking for folders and files in \""
						    + explorer2.Folder + checkBox.Label
						    + "\", which are not in \"" + explorer1.Folder + checkBox.Label
						    + "\"");
						Add("");
						CheckOld(explorer2.Folder + checkBox.Label);
						
						Add("");
						Add("### Phase 3 ### Looking for folders and files, which are not in \"" 
						    + explorer2.Folder + checkBox.Label
						    + "\" or being updated in \"" + explorer1.Folder + checkBox.Label
						    + "\"");
						Add("");
						CheckCurrent(explorer1.Folder + checkBox.Label);
					}
				}
				
				Add("");
				AddBox("Stop: " + explorer1.Folder + checkBox.Label);
				
			}
		}
		if (arrayListCopyMainFolder.Count != 0)
		{
			foreach (object o in arrayListCopyMainFolder)
			{
				Add("ATTENTION: The main folder \"" + (string)o + "\" does not exist yet and would be copied entirely.");
			}
			Add("");
		}
			
		if (!bTest)
		{
			CreateImage();
			bCanceled = false;
		}
		DateTime dateTimeStop = DateTime.Now;
		TimeSpan timeSpan = dateTimeStop - dateTimeStart;
		AddBox((bCanceled ? "Canceled" : "Completed")
			+ String.Format(" at {0:D2}:{1:D2}:{2:D2}", dateTimeStop.Hour, dateTimeStop.Minute, dateTimeStop.Second) 
			+ String.Format(" (duration: {0:D2}:{1:D2}:{2:D2})", timeSpan.Hours, timeSpan.Minutes, timeSpan.Seconds));
		//listBox.SelectedIndex = listBox.Items.Count - 3;
		bCanceled = true;
		this.cc();
		
		ShowInfos();
		sizeSorter.Show();
	}
	
	void ShowInfos()
	{
		MessageType mt = MessageType.Info;
		string strText = "The image was created successfully.";
		if (bTest)
		{
			strText = "The folders and files have been checked.";
		}
		else if (arrayListError.Count != 0)
		{
			mt = MessageType.Error;
			strText = "Errors occurred:\n";
			foreach (object o in arrayListError)
			{
				strText += "\n" + o;
			}
		}
		Message(mt, strText);
		Process.Start(file);
	}
    void Steuerung()
    {
    	
    	VBox all = new VBox();
		this.Add(all);
		
		HBox buttons = new HBox();
		all.PackStart(buttons, false, false, Var.padding);
    	//int y = Mvar.abstand;
    	//listBox.Location = new Point(Mvar.abstand, y);
		//listBox.Size = new Size(950, 650);
		//listBox.Parent = this;
		//y += listBox.Height + Mvar.abstand;
		
		Button buttonStart = new Button("Real Image");
    	buttonStart.Clicked += new EventHandler(Button_Click);
    	buttonStart.Name = "Start";
    	buttons.PackStart(buttonStart, false, false, Var.padding);
    	
    	Button buttonTest = new Button("Check");
    	buttonTest.Clicked += new EventHandler(Button_Click);
    	buttonTest.Name = "Test";
    	buttons.PackStart(buttonTest, false, false, Var.padding);
    	
    	Button buttonCancel = new Button("Cancel");
		buttonCancel.Clicked += new EventHandler(Button_Click);
		buttonCancel.Name = "Cancel";
    	buttons.PackStart(buttonCancel, false, false, Var.padding);
    	
    	checkBox.Active = true;
    	//checkBox.Enabled = false;
    	checkBox.Label = "Supervision";
    	buttons.PackStart(checkBox, false, false, Var.padding);
    	
    	all.PackStart(superviseAction, false, false, Var.padding);
    	//all.PackStart(superviseSize, false, false, Var.padding);
    	
    }
    
    void This_DeleteEvent_Here(object o, DeleteEventArgs args)
    {
    	if (!bCanceled)
    	{
    		Message(MessageType.Warning, (bTest ? "The test" : "The creation") + " is still running ...");
    		// args.Cancel = true;
    	}
    }
}
