/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using MiBibGtk;
using System;

internal class MainForm : Fenster
{
	Explorer explorer1 = new Explorer(true);
    Explorer explorer2;
    
    internal MainForm() : base("Backup", Var.icon)
    {
    	explorer2 = new Explorer(false, explorer1);
        Steuerung();
        
    	this.SetDefaultSize(Var.width, Var.height);
    	this.SetPosition(WindowPosition.Center);
    	
        this.Focus = explorer1.browse;
		//this.Icon = new Resource().Get("next.png");
    }
    
	internal static MainForm mf;
    
	internal static void Start()
    {
    	Application.Init();
		mf = new MainForm();
		mf.ShowAll();
		Application.Run();
    }
    
	void Start_Click(object o, EventArgs ea)
    {
		Console.WriteLine("explorer1.Folder='" + explorer1.Folder + "'");
		Console.WriteLine("explorer2.Folder='" + explorer2.Folder + "'");
		
    	if (   explorer1.Folder == string.Empty
    	    || explorer2.Folder == string.Empty)
    	{
    		Message(MessageType.Warning, "Source and target should be choosen.");
    		return;
    	}
    	Button button = (Button)o;
    	if (button.Name == "Leer")
    	{
    		// LeerImage leerImage = new LeerImage(explorer1, explorer2);
    		Message(MessageType.Warning, "This function should be checked in detail first.");
    		return;
    	}
    	else if (button.Name == "Start")
    	{
    		Message(MessageType.Warning, "This function should be checked in detail first.");
    		return;
    	}
    	else if (button.Name != "Test") //  && button.Name != "Start"
    	{
    		Message(MessageType.Warning, "Do not know what to do with button.Name '" + button.Name + "' in MainForm.Start_Click.");
    		return;
    	}
    	ImageForm imageForm = new ImageForm(button.Name == "Test", explorer1, explorer2);
    	imageForm.Show();
    	if (imageForm.bOk) imageForm.Start();
    }
    
    void Steuerung()
    {
    	HBox main = new HBox();
		this.Add(main);
		
    	main.PackStart(explorer1, true, true, 0);
    	
    	VBox buttons = new VBox();
		main.PackStart(buttons, false, false, Var.padding);
		
    	main.PackStart(explorer2, true, true, 0);
    	
    	Button buttonLeer = new Button("Empty image");
    	buttonLeer.Clicked += new EventHandler(Start_Click);
    	buttonLeer.Name = "Leer";
    	buttons.PackStart(buttonLeer, false, false, Var.padding);
    	
    	Button buttonStart = new Button("Real image");
    	buttonStart.Clicked += new EventHandler(Start_Click);
    	buttonStart.Name = "Start";
    	buttons.PackStart(buttonStart, false, false, Var.padding);
    	
    	Button buttonTest = new Button("Check");
    	buttonTest.Clicked += new EventHandler(Start_Click);
    	buttonTest.Name = "Test";
    	buttons.PackStart(buttonTest, false, false, Var.padding);
    }
}
