/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;

class SizeSorter
{
	ArrayList[] al;
	int min = 30;
	int[] level = new int[]
	{
		1024, 500, 200, 100
	};
	
	string file = "alldat" + Path.DirectorySeparatorChar + "Backup-Sizes.txt";
	
	internal SizeSorter()
	{
		al = new ArrayList[level.Length];
		for (int i = 0; i < level.Length; i++) al[i] = new ArrayList();
	}
	
	internal void Add(double size, string path, string type)
	{
		if (size < min * Mvar.mb) return;
		string text = " " + type + " " + path;
		for (int i = level.Length - 1; i > 0; i--)
		{
			if (size < level[i] * Mvar.mb)
			{
				al[i].Add(String.Format("{0:F0} MB", size/Mvar.mb) + text);
				return;
			}
		}
		al[0].Add(String.Format("{0:F1} GB", size/Mvar.gb) + text);
	}
	
	internal void Show()
	{
		try { File.Delete(file); } catch { }
		Log.Add(file, DateTime.Now.ToLongDateString() + " " + DateTime.Now.ToLongTimeString());
		for (int i = 0; i < level.Length; i++)
		{
			if (al[i].Count > 0)
			{
				Log.Add(file, ((i == 0) ? "MEHR ALS" : "BIS ZU") + " " + level[i] + " MB:");
				foreach (string str in al[i]) Log.Add(file, str);
				Log.Add(file, "");
			}
		}
		Process.Start(file);
	}
	
	

}
