/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.Globalization;
using System.IO;

class Add
{
	//static ArrayList singCollection = new ArrayList();
	static bool foundAudioFilesInAlbum = false;
	static readonly bool test = false;
	static int sings;
	static Album lastAlbum;
	static string lastDir = "";
	
	static string AddAlbum(string file, int dir_id, ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		string dir = MySql3.PathTreatment(Path.GetDirectoryName(file));
		if (dir == lastDir) return "";
		string error = "";
		SaveLastAlbum(ref mca, ref max_ids);
		lastAlbum = new Album();
		foundAudioFilesInAlbum = false;
		error += lastAlbum.Create(dir, dir_id, ref max_ids);
		if (error == "") lastDir = dir;
		return error;
	}
	
	static string AddFile(string file, int dir_id, ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		string error = "";
		if (Ext.Add2MySql(file))
		{
			error += AddAlbum(file, dir_id, ref mca, ref max_ids);
			Sing sing = new Sing();
			sing.Create(MySql3.PathTreatment(file), lastAlbum, ref max_ids);
			if (sing.rnd) foundAudioFilesInAlbum = true;
			mca[2].Add(sing.SaveInsertQuery());
			//if (sing.rnd) mca[4].Add(sing.SaveInsertQueryRandom());//ref max_ids));
			// singCollection.Add(sing);
			// if (singCollection.Count == 75) // zwischen 20 und 100
			// {
			// 	error += Sing.SaveCollection(ref singCollection);
			// }
			sings++;
		}
		else if (file == Img.folder) error += AddAlbum(file, dir_id, ref mca, ref max_ids);
		return error;
	}
	
	internal static string MainDir(string dir, ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		string error = "";
		DateTime dt = DateTime.Now;
		if (dir == "test")
		{
			dir = SysInfo.Unix ? "/a/e/test" : "E:/test";
		}
		if (dir == "www")
		{
			dir = "//Www/C/phpdev/dyn/MUSIK";
		}
		dir = MySql3.PathTreatment(dir);
		if (Dir.Exists(dir))
		{
			string str = "directory \"" + dir + "\" already exists";
			Console.WriteLine(str);
			return error + str + "\n";
		}
		if (!Directory.Exists(dir))
		{
			string str = "directory \"" + dir + "\" does not exist";
			Console.WriteLine(str);
			return error + str + "\n";
		}
		string name = Path.GetFileName(dir);
		bool rnd = Rnd.Check(ref name);
		int id = MainDirSave(dir, name, rnd, ref mca, ref max_ids);
		if (id == 0) return error + "Add.MainDirSave returns 0 as an id\n";
		
		sings = 0;
		error += SearchDir(dir, id, ref mca, ref max_ids);
		// error += Sing.SaveCollection(ref singCollection);
		SaveLastAlbum(ref mca, ref max_ids);
		
		int albums = Dir.UpdateNumbers(id, sings);
		TimeSpan tsp = DateTime.Now - dt;
		Console.WriteLine("\n"
		    + "\n\t--------"
		    + "\n\tfound in " + dir
		    + "\n\t--------"
			+ "\n\talbums\t " + albums
			+ "\n\ttracks\t " + sings
			+ "\n\ttime\t " 
			+ Math.Floor(tsp.TotalMinutes) + " min " + tsp.Seconds + " sec"
			+ "\n\n"
			);
		return error;
	}
	
	static int MainDirSave(string dir, string name, bool rnd, ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		if (test) Console.WriteLine(dir + "\n" + name);
		max_ids[0]++;
		/*
		mca[0].Add("INSERT INTO dir VALUES("
		           + max_ids[0] + ","
		           + "0,"
		           + "0,"
		           + (rnd ? 1 : 0) + ","
		           + "\"" + name + "\","
		           + "\"" + dir + "\""
		           + ");"
		           );
		*/
		DateTime dt = new DateTime(1988, 8, 8, 8, 8, 8);
		try { dt = Directory.GetLastWriteTime(dir); } catch { }
		mca[0].Add("INSERT INTO dir SET "
		           + "id=" + max_ids[0] + ","
		           + "albums=0,"
		           + "changed='" + Kalender.DateTime2MySqlDateTime(dt) + "',"
		           + "sings=0,"
		           + "rnd=" + (rnd ? 1 : 0) + ","
		           + "name=\"" + name + "\","
		           + "path=\"" + dir + "\""
		           + ";"
		           );
		
		
		// MySqlB.Exec(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		//            "INSERT INTO dir SET "
		//            + "name=\"" + name + "\","
		//            + "path=\"" + dir + "\","
		//            + "rnd=" + (rnd ? 1 : 0)
		//            );
		// return MySqlB.Max(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "dir", "id");
		return max_ids[0];
	}
	
	static void SaveLastAlbum(ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		if (lastAlbum == null) return;
		if (!foundAudioFilesInAlbum) lastAlbum.rnd = false;
		lastAlbum.audio = foundAudioFilesInAlbum;
		mca[1].Add(lastAlbum.Save());
		//if (lastAlbum.rnd) mca[3].Add(lastAlbum.SaveRandom());//ref max_ids));
		lastAlbum = null;
	}
	
	static string SearchDir(string dir, int idDir, ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		string error = "";
		if (InOut.SpecialFolder(dir)) return error;
		error += SearchFiles(dir, idDir, ref mca, ref max_ids);
		try
		{
			string[] astr = Directory.GetDirectories(dir);
			foreach (string str in astr)
			{
				//if (test) Console.WriteLine(str);
				error += SearchDir(str, idDir, ref mca, ref max_ids);
			}
		}
		catch (Exception e)
		{
			Error.ExceptionMessage(e.Message, dir);
			error += dir + " (" + e.Message + ")\n";
		}
		return error;
	}
	
	static string SearchFiles(string dir, int idDir, ref MySqlCollArray[] mca, ref int[] max_ids)
	{
		string error = "";
		try
		{
			foreach (string str in Directory.GetFiles(dir)) 
			{
				error += AddFile(str, idDir, ref mca, ref max_ids);
			}
		}
		catch (Exception e)
		{
			Error.ExceptionMessage(e.Message, dir);
			error += dir + " (" + e.Message + ")\n";
		}
		return error;
	}

}
