/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.IO;

class Album
{
	internal bool audio = false;
	internal bool exists = false;
	internal bool rnd;
	internal int dir_id = 0;
	internal int id = 0;
	internal string name;
	internal static string sequence = di.artist[0] + di.title[0] + di.year[0];
	internal string path;
	
	internal Album() { }
	
	internal Album(int id) { Load("id", id.ToString()); }
	
	internal Album(string path) { Load("path", path); }
	
	internal string Create(string path, int dir_id, ref int[] max_ids)
	{
		this.dir_id = dir_id;
		UpdateFromPath(path);
		return Insert(ref max_ids);
	}
	
	internal string ButtonTitle { get { return name; } }
	internal string FullTitle { get { return path; } }
	
	internal string Directory(int i)
    {
		return Dir.Directory(path, i);
	}
	
	static internal int FullPath2Id(string fullPath)
	{
		return MySql3.Id(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                "album", "path", MySql3.PathTreatment(Path.GetDirectoryName(fullPath)));
	}
	
	internal static ArrayList Id2SingArrayListPaths(int id)
	{
		ArrayList al = new ArrayList();
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                    "SELECT path FROM sing WHERE album_id="
		                    + id + " AND type='audio' ORDER BY name");
		if (!m.open) return al;
		while (m.r.Read()) al.Add(m.r["path"]);
		m.Close();
		return al;
	}
	
	string Insert(ref int[] max_ids)
    {
    	//string error = MySqlB.Exec(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		//                          "insert into album set dir_id=" + dir_id);
    	//if (error != "") return error;
    	//id = MySqlB.Max(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "album", "id");
    	//if (id < 1) error += "Album.Insert returns id < 1\n"; 
    	//return error;
    	max_ids[1]++;
    	id = max_ids[1];
    	return "";
    }
    
	string Load(string column, string cellValue)
	{
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                    "SELECT audio,dir_id,id,name,path,rnd FROM album WHERE "
						    + column + "=\"" + cellValue + "\"");
		if (!m.open) return "MySQL is not open <- " + column + " " + cellValue + "\n";
		if (m.r.Read())
		{
			audio = m.r["audio"].ToString() == "1";
			dir_id = (int)m.r["dir_id"];
			id = (int)m.r["id"];
			name = (string)m.r["name"];
			path = (string)m.r["path"];
			rnd = m.r["rnd"].ToString() == "1";
			exists = true;
		}
		m.Close();
		return "";
	}
	
	internal string Save()
	{
		return "INSERT INTO album VALUES("
		    + id + ","
			+ dir_id + ","
		    + (audio ? 1 : 0) + ","
		    + (rnd ? 1 : 0) + ","
		    + "\"" + name + "\","
		    + "\"" + path + "\""
			+ ");"
		    ;
	}
	
	internal string Save(bool update)
	{
		string cmd = (update ? "UPDATE" : "INSERT INTO") + " album SET "
		    + "audio=" + (audio ? "1" : "0") + ","
		    + "dir_id=" + dir_id + ","
		    + (update ? "" : "id=" + id + ",")
		    + "name=\"" + name + "\","
		    + "path=\"" + path + "\","
		    + "rnd=" + (rnd ? "1" : "0")
		    + (update ? (" WHERE id=" + id) : "") + ";";
		if (update) 
		{
			new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, cmd);
			return "";
		}
		return cmd;
	}
	/*
	internal string SaveRandom()//ref int[] max_ids)
	{
		//max_ids[3]++;
		return "INSERT INTO random_album VALUES("
			//+ max_ids[3] + ","
			+ id + ","
			+ dir_id + ","
			+ "\"" + path + "\""
			+ ");"
			;
	}
	*/
	internal static ArrayList Sings(int id)
	{
		ArrayList al = new ArrayList();
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                    "SELECT id FROM sing WHERE album_id="
		                    + id + " ORDER BY name");
		if (!m.open) return al;
		while (m.r.Read()) al.Add(m.r["id"]);
		m.Close();
		return al;
	}
	
	internal string Update(string path)
    {
    	UpdateFromPath(path);
    	return Save(true);
    }
	
    void UpdateFromPath(string path)
    {
    	this.path = path;
    	name = Peculiar.Substitute(path);
    	rnd = Rnd.Check(ref name);
    }
	
	internal void WriteLine(string sequence)
	{
    	string str = "";
    	if (sequence == di.details[0]) sequence = "ifa";
    	char[] ach = sequence.ToCharArray();
    	for (int i = 0; i < ach.Length; i++)
    	{
    		string opt = ach[i].ToString().ToLower();
    		if (opt == di.index[0]) str += id;
    		
    		if (i < ach.Length - 1) str += ((i == 0 && opt == di.index[0]) ? "\t" : Var.sepOutput);
    	}
    	Console.WriteLine(str);
	}
	
	internal static void WriteLine(int id, string sequence)
	{
		Album a = new Album(id);
		a.WriteLine(sequence);
	}
}

