/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;

class Command
{
	internal static string[] Split(string str)
	{
		string[] astr = str.Split(new char[]{' '}, 2);
		string[] cmd = new string[]{str, astr[0], astr.Length == 2 ? astr[1] : ""};
		return cmd;
	}
    
	internal static ArrayList ToParam(string strCmd)
	{
		ArrayList al = new ArrayList();
		bool bOption = false;
		bool bText = false;
		char[] ach = strCmd.ToCharArray();
		int i = 0;
		string str = "";
		while (i < ach.Length)
		{
			char ch = ach[i];
			if (ch == '-')
			{
				str += ch;
				if (!bText) bOption = true;
			}
			else if (ch == '"')
			{
				str += "\"";
				if (bText) { al.Add(str); str = ""; }
				bText = !bText;
			}
			else if (ch == ' ')
			{
				if (bText) str += ch;
				else
				{
					if (bOption) bOption = false;
					if (str != "") al.Add(str);
					str = "";
				}
			}
			else str += ch;
			i++;
		}
		if (str != "") al.Add(str);
		return al;
	}	
}
