/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.IO;

class Database
{
	//static bool test = true;
	
	internal static void Test()
	{	
		Drop(false);
		Create();
		ArrayList al = new ArrayList();
		al.Add("E:/Test");
		al.Add("N:/Great");
		al.Add("S:/1a");
		UpdateFromArrayList(al, false, false);
	}
	
	static MySqlCollArray[] mca;
	
	// #############################################################################
	// #                                                                           #
	// # MENUS                                                                     #
	// #                                                                           #
	// #############################################################################
	
	static void AddDir(string str)
	{
		while (str != di.quit[0])
		{
			Input.prompt = di.dbAddDir[1];
			if (str == "") str = Input.GetLine();
			if (Input.Quit(str)) break;
			// Add.MainDir(str);
    		break;
    	}
    }
	
	static bool Confirm(bool confirm, string message)
	{
		if (!confirm) return true;
		
		Console.WriteLine("");
		Console.WriteLine("\t" + message.ToUpper() + " ???");
		Console.WriteLine("");
		Console.WriteLine("\tCONFIRM !!!");
		Console.WriteLine("");
		
		// if (test) return true; 
		
		string str = Input.GetLine();
		Output.Clear();
		if (str != Ini.GetString("MySQL")) return false;
		return true;
	}
	
	internal static void Create()
	{
		MySqlMV.CreateDb();
	}
	
	static void CreateFromFile(bool confirm)
    {
		if (!(Confirm(confirm, "drop database and create from file"))) return;
    	Drop(false);
    	Create();
    	UpdateFromFile(false, true);
    }
	/*
	internal static void DirectoryChangesCheckOnStart()
	{
		Dirs dirs = new Dirs("");
		
    	ArrayList al = new ArrayList();
    	foreach (Dir dir in dirs.al)
    	{
    	//Dir dir = (Dir)dirs.al[0];
    		DateTime dt = DateTime.Now;
    		//try { dt = Directory.GetLastWriteTime(dir.path); } catch { }
    		dt = InOut.GetLastWriteTime(dir.path, new DateTime(1111, 11, 11, 11, 11, 11));
    		//if (dt > dir.changed)
    		//{
    			Console.WriteLine("changed: " + dir.changed + " ... " + dt + " ... " + dir.path);
    			//al.Add(dir.path);
    		//}
    	}
    	string error = "";//UpdateFromArrayList(al, false, false);
    	if (error != "") Console.WriteLine(error);
	}
	*/
	internal static bool Drop(bool confirm)
	{
		if (!(Confirm(confirm, "drop database"))) return false;
		new MySql3("mysql", Mvar.pw, Mvar.server, Mvar.user, "DROP DATABASE " + Mvar.db);
		// MySqlMV.DropTables(ref ms);
		return true;
	}
	/*
    static void MySqlCollCloseFile()
    {
    	for (int i = 0; i < mca.Length; i++)
    	{
    		mca[i].CloseFile();
    	}
    }
    */
	static TimeSpan MySqlCollExecuteFile()
    {
    	TimeSpan tsp = new TimeSpan();
    	for (int i = 0; i < mca.Length; i++)
    	{
    		mca[i].Execute(Ini.GetString("MySQL-Database"), Ini.GetString("MySQL"), Ini.GetString("MySQL-Server"), Ini.GetString("MySQL-User"));
    		tsp += mca[i].tsp;
    	}
    	return tsp;
    }
    
	static void MySqlCollInit()
    {
		mca = new MySqlCollArray[5];
    	for (int i = 0; i < mca.Length; i++) mca[i] = new MySqlCollArray(); // MainClass.datpath + "/temp_mca_" + i + ".txt");
    }
    
	static void RemoveDir(bool removeNonexistingArtists, int id)
	{
		Console.WriteLine("\n\tremove dir " + id);
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "DELETE FROM album WHERE dir_id=" + id);
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "DELETE FROM dir WHERE id=" + id);
		//new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		//           "DELETE FROM random_album WHERE dir_id=" + id);
		//new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		//           "DELETE FROM random_sing WHERE dir_id=" + id);
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "DELETE FROM sing WHERE dir_id=" + id);
	}
	
	static void RemoveDir(bool removeNonexistingArtists, string strName)
	{
		RemoveDir(removeNonexistingArtists, 
		          MySql3.Id(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                   "dir", "name", "strName"));
	}
	
	static void RemoveDirQueries(int id, ref MySqlCollArray[] mca)
	{
		mca[0].Add("DELETE FROM album WHERE dir_id=" + id);
       	mca[0].Add("DELETE FROM dir WHERE id=" + id);
       	//mca[0].Add("DELETE FROM random_album WHERE dir_id=" + id);
       	//mca[0].Add("DELETE FROM random_sing WHERE dir_id=" + id);
       	mca[0].Add("DELETE FROM sing WHERE dir_id=" + id);
	}
	
	static void RemoveDirMenu(string cmd)
	{
		while (cmd != di.quit[0])
		{
			Dir.ShowDirs();
			if (cmd == "") cmd = Input.GetLine(di.dbRemoveDir[1]);
			if (Input.Quit(cmd)) break;
			try { RemoveDir(true, Int32.Parse(cmd)); }
			catch { RemoveDir(true, cmd); }
    		break; // for now, only one
    	}
    }
	
	static void UpdateDir(int id)
	{
		//Dir dir = new Dir(id);
		RemoveDir(true, id);
		//Add.MainDir(dir.path);
	}
	
	static void UpdateDirMenu(string cmd)
	{
		while (cmd != di.quit[0])
		{
			Dir.ShowDirs();
			if (cmd == "") cmd = Input.GetLine(di.dbUpdateDir[1]);
			if (Input.Quit(cmd)) break;
			int iDir;
			try { iDir = Int32.Parse(cmd); }
			catch { Output.Message("id not correct"); break; }
			UpdateDir(iDir);
    		break; // for now, only one
    	}
	}
	
	internal static void Start(string cmd)
    {
        bool bShow = cmd == "";
		while (true)
		{
			Input.prompt = di.db[1];
			if (bShow) StartMenu();
			bShow = false;
			if (cmd == "") cmd = Input.GetLine();
			string[] acmd = Command.Split(cmd);
			if (Input.Quit(acmd[1])) break;
			if (Input.Clear(acmd[1]))				{ Output.Clear(); }
			else if (Input.Help(acmd[1]))			{ bShow = true; }
			else if (acmd[1] == "")					{  }
			else
			{
				//ms = new MySqlSource();
			if (acmd[1] == di.dbAddDir[0])		{ AddDir(acmd[2]); }
				else if (acmd[1] == di.dbCreate[0])		{ Create(); }
			else if (acmd[1] == di.dbCreateF[0])	{ CreateFromFile(true); }
				else if (acmd[1] == di.dbDrop[0])		{ Drop(true); }
			else if (acmd[1] == di.dbRemoveDir[0])	{ RemoveDirMenu(acmd[2]); }
			else if (acmd[1] == di.dbUpdateDir[0])	{ UpdateDirMenu(acmd[2]); }
			else if (acmd[1] == di.dbUpdateF[0])	{ UpdateFromFile(true, false); }
			else if (cmd == "test")
			{
				//Drop(true);
				//MySqlMV.CreateDb();
				//AddDir("test");
			}
			else { bShow = true; }
				
				// ms.CreateFile("temp.txt");
				// ms.Show();
				// ms = null;
			}
			cmd = "";
		}
    }
	
    static void StartMenu()
    {
        Output.Offer2(di.dbAddDir);
		Output.Offer2(di.dbCreate);
		Output.Offer2(di.dbCreateF);
		Output.Offer2(di.dbDrop);
		Output.Offer2(di.dbCommand);
		Output.Offer2(di.dbRemoveDir);
		Output.Offer2(new string[]{"test", "test"});
		Output.Offer2(di.dbUpdateDir);
		Output.Offer2(di.dbUpdateF);
    }
    
    public static string UpdateFromArrayList(ArrayList al, bool confirm, bool create)
    {
    	string error = "";
    	bool ok = true;
    	foreach (string str in al)
    	{
    		if (!Directory.Exists(str))
    		{
    			ok = false;
    			Console.WriteLine("ERROR (directory does not exist) -> " + str);
    		}
    	}
    	if (!ok) 
    	{
    		string str = "operation cancelled";
    		Console.WriteLine("\n\t" + str + "\n");
    		return str;
    	}
    	if (confirm)
    	{
    		foreach (string str in al) Console.WriteLine(str);
    		if (!Confirm(confirm, "update above listed directories")) return "operation cancelled";
    	}
    	
    	DateTime dt = DateTime.Now;
    	int[] max_ids = new int[5];
    	max_ids[0] = MySql3.Max(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "dir", "id");
    	max_ids[1] = MySql3.Max(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "album", "id");
    	max_ids[2] = MySql3.Max(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "sing", "id");
    	
    	MySqlCollInit();
    	
    	foreach (string str in al)
    	{
    		if (!create)
    		{
    			int id = MySql3.Id(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    			                  "dir", "path", MySql3.PathTreatment(str));
    			if (id > 0) RemoveDirQueries(id, ref mca);
    		}
    		error += Add.MainDir(str, ref mca, ref max_ids);
    	}
    	
		// MySqlCollCloseFile();
		TimeSpan tspMySqlColls = MySqlCollExecuteFile();
		
    	Console.WriteLine("\n-----"
    	                + "\nREADY"
    	                + "\n-----"
    	                + "\n");
    	int albums = 0;
    	int dirs = 0;
    	int sings = 0;
    	foreach (string str in al)
    	{
			int id = MySql3.Id(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    		                  "dir", "path", MySql3.PathTreatment(str));
			Dir dir = new Dir(id);
			Console.WriteLine("directory \t" + dir.name + "\n"
							+ "albums \t\t" + dir.albums + "\n"
							+ "files \t\t" + dir.sings + "\n");
			albums += dir.albums;
			dirs++;
			sings += dir.sings;
    	}
    	
    	if (error != "") Log.Add(Mvar.logError, "\nsummary" + "\n-------\n" + error, true);
    	TimeSpan tsp = DateTime.Now - dt;
    	Console.WriteLine("\n-----"
				    	+ "\nERROR\n"
						+ (error == "" ? "none!" : error) + "\n"
						+ "-----\n"
				    	+ "TOTAL\n"
						+ "-----\n"
						+ "albums \t\t" + albums + "\n"
						+ "files \t\t" + sings + "\n"
						+ mca.Length + " query-colls \t" + Math.Floor(tspMySqlColls.TotalMinutes) + " min " + tspMySqlColls.Seconds + " sec\n"
						+ "total time \t" + Math.Floor(tsp.TotalMinutes) + " min " + tsp.Seconds + " sec\n"
						);
    	mca = null;
    	return error;
    }
    
    static void UpdateFromFile(bool confirm, bool create)
    {
    	ArrayList al = InOut.File2ArrayList(SysInfo.IniFile("dir"), true);
    	UpdateFromArrayList(al, confirm, create);
    }
    /*
    internal static string UpdateRandom()
    {
    	string error = "";
    	error += UpdateRandomPath("album");
    	error += UpdateRandomPath("sing");
    	return error;
    }
    
    static string UpdateRandomPath(string table)
    {
    	DateTime dateTimeStart = DateTime.Now;
    	int number = 500;
    	string error = "";
    	//new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	//                    "DROP TABLE random_" + table);
    	//if (table == "album" ) MySqlMV.CreateTableRandomAlbum();
    	//else MySqlMV.CreateTableRandomSing();
    	string cmd = "SELECT path FROM " + table + " WHERE rnd=1";
    	MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, cmd);
    	if (!m.open) return "UpdateRandomPath MySQL not open <- " + cmd + "\n";
    	ArrayList al = new ArrayList();
    	while (m.r.Read()) al.Add((string)m.r["path"]);
    	m.Close();
    	
    	int count = 0;
    	ArrayList alPart = new ArrayList();
    	foreach (string str in al)
    	{
    		bool b = true;
    		if (table == "album" && !File.Exists(str + "/" + Img.folder))
		    {
		    	b = false;
		    }
    		if (b)
    		{
	    		alPart.Add(str);
	    		if (++count == number)
	    		{
	    			error += UpdateRandomPathExecute(table, alPart);
	    			alPart = new ArrayList();
	    			count = 0;
	    		}
    		}
    	}
    	error += UpdateRandomPathExecute(table, alPart);
    	DateTime dateTimeEnd = DateTime.Now;
    	TimeSpan timeSpan = dateTimeEnd - dateTimeStart;
    	Log.Add(Mvar.logDevelop, "UpdateRandomPath " + al.Count + " " + table + "s in "
    	        + number + "er-Paketen in " + timeSpan.TotalSeconds + " sec", true);
    	return error;
    }
    
    static string UpdateRandomPathExecute(string table, ArrayList alPart)
    {
    	string error = "";
    	if (alPart.Count == 0) return error;
    	string cmd = "INSERT INTO random_" + table + "(path) VALUES(\"" + alPart[0] + "\")";
    	for (int i = 1; i < alPart.Count; i++)
    	{
    		cmd += ",(\"" + alPart[i] + "\")";
    	}
    	new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, cmd);
    	return error;
    }
    */
}
