/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.IO;

class Dir
{
	internal bool rnd = false;
	internal DateTime changed;
	internal int id;
	internal int albums = 0;
	internal int sings = 0;
	internal string name = "";
	internal string path = "";
	
	internal Dir() { }
	
	internal Dir(int id)
	{
		this.id = id;
		Load();
	}
	
	internal static string Directory(string strFile, int i)
    {
		string str = MySql3.PathTreatment(Path.GetDirectoryName(strFile));
        if (i == 0) return str;
        string[] astr = str.Split('/');//Path.DirectorySeparatorChar);
        if (i < 0)
        {
            str = astr[0];
            for (int k = 1; k < astr.Length + i; k++)
            {
                str += Path.DirectorySeparatorChar + astr[k];
            }
            return str;
        }
        if (astr.Length < i) return string.Empty;
        return astr[astr.Length - i];
    }
	
    internal static bool Exists(string strDir)
    {
    	int id = MySql3.Results(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	                          "SELECT id FROM dir WHERE path=\"" + strDir + "\"");
		// Console.WriteLine ("" + id + " - " + strDir);
		return id > 0;
    }
    
    void Load()
	{
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                      "SELECT albums,name,path,rnd,sings FROM dir WHERE id=" + id);
		if (!m.open) return;
		if (m.r.Read())
		{
			rnd = m.r["rnd"].ToString() == "1";
			albums = (int)m.r["albums"];
			sings = (int)m.r["sings"];
			name = (string)m.r["name"];
			path = (string)m.r["path"];
		}
		m.Close();
	}
	
	internal static ArrayList GetArrayList()
    {
    	ArrayList al = new ArrayList();
    	MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	                    "SELECT path FROM dir");
    	if (!m.open) return al;
    	while (m.r.Read())
    	{
    		al.Add(m.r["path"].ToString());
    	}
    	m.Close();
    	return al;
    }
    
	internal static int Path2Id(string folder)
	{
		int id = 0;
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                    "SELECT id,path FROM dir");
		if (!m.open) return 0;
		while (m.r.Read())
		{
			if (folder.IndexOf((string)m.r["path"]) != -1) id = (int)m.r["id"];
		}
		m.Close();
		return id;
	}
	
    internal static void ShowDirs()
    {
    	MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	                    "SELECT id,path FROM dir");
    	if (!m.open) return;
    	while (m.r.Read())
    	{
    		Console.WriteLine("" + m.r["id"] + "\t" + m.r["path"]);
    	}
    	m.Close();
    }
    
    internal static int UpdateNumbers(int id, int sings)
    {
    	int iAlbums = MySql3.Results(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	                            "SELECT id FROM album WHERE dir_id=" + id);
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	           "UPDATE dir SET "
		                      + "sings=" + sings + ","
		                      + "albums=" + iAlbums
		                      + " WHERE id=" + id);
		return iAlbums;
    }
}
