/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBib;
using System;
using System.Collections;
using System.IO;

class Ext
{
    internal enum Typen { All,
						  Album,
    					  audio, 
    					  broken,
    					  browser, 
    					  executable,
    					  folder,
    					  image,
    					  info,
    					  link,
    					  none, 
    					  other, 
    					  playlist,
    					  text,
    					  unknown, 
    					  video,
    					  wave
						};
	
	internal static bool ProgramIsDefinedInIni(Typen typ)
	{
		return typ == Typen.image || typ == Typen.video || typ == Typen.browser || typ == Typen.text;
	}
	
	internal static bool Add2MySql(string path)
	{
		Typen typ = Path2Type(path);
		return typ == Typen.audio
		    || typ == Typen.broken
		    || typ == Typen.browser
		    || typ == Typen.image
		    || typ == Typen.info
		    || typ == Typen.link
		    || typ == Typen.playlist
		    || typ == Typen.text
		    || typ == Typen.video
		    || typ == Typen.wave
			;
	}
	/*
    internal static string Path2Program(string path)
    {
		return Extension2Program(Path.GetExtension(path));
    }
    */
    internal static string Path2Program(string path)
    {
    	Typen typ = Path2Typ(path);
    	return Typ2Program(typ);
    }
    
    static string Typ2Program(Typen typ)
    {
    	if (typ == Typen.image) return Ini.GetString("ImageProgram");
    	else return "";
    }
    
    internal static Typen Path2Typ(string path)
    {
    	Typen type = Path2Type(path);
    	//Console.WriteLine(type + ":" + path);
    	return type;
    }
    
    static Typen Path2Type(string path)
    {
    	string ext = Path.GetExtension(path);
        ext = ext.ToLower();

             if (   ext == ".mp3"
                 || ext == ".wma"
                )
        {
            return Typen.audio;
        }
        else if (   ext == ".m3u")
        {
            return Typen.playlist;
        }
        else if (   ext == ".bmp"
                 || ext == ".gif"
                 || ext == ".hpi"
                 || ext == ".ico"
                 || ext == ".j31"
                 || ext == ".jpeg"
                 || ext == ".jpg"
                 || ext == ".jps"
                 || ext == ".pcd"
                 || ext == ".png"
                 || ext == ".tif"
                )
        {
            return Typen.image;
        }
        else if (   ext == ".cue"
                 || ext == ".info"
                 || ext == ".log"
                 || ext == ".nfo"
                 || ext == ".txt"
                )
        {
            return Typen.text;
        }
        else if (   ext == ".htm"
                 || ext == ".html"
                )
        {
            return Typen.browser;
        }
        else if (   ext == ".link"
                )
        {
            return Typen.link;
        }
        else if (   ext == ".avi"
                 || ext == ".divx"
                 || ext == ".mov"
                 || ext == ".mp4"
                 || ext == ".mpeg"
                 || ext == ".mpg"
                 || ext == ".swf"
                 || ext == ".vob"
                 || ext == ".wmv"
                 )
        {
            return Typen.video;
        }
        else if (   ext == ".broken"
                 || ext == ".fehlt"
                 || ext == ".kaputt"
                 || ext == ".missing"
                 || ext == ".search"
                )
        {
            return Typen.broken;
        }
        else if (   ext == ".awt"
                 || ext == ".naja"
                 || ext == ".suche"
                )
        {
            return Typen.info;
        }
        else if (   ext == ".ape" // foobar
                 || ext == ".asf"
                 || ext == ".aif"
                 || ext == ".doc"
                 || ext == ".dot"
                 || ext == ".flac" // foobar
                 || ext == ".mid"
                 || ext == ".ogg"
                 || ext == ".pdf"
                 || ext == ".pps"
                 || ext == ".ram"
                 || ext == ".rtf"
                 || ext == ".xls"
                )
        {
            return Typen.other;
        }
        else if (   ext == ".bat"
                 || ext == ".dll"
                 || ext == ".exe"
                 || ext == ".ini"
                 || ext == ".lnk"
                 || ext == ".scr"
                )
        {
            return Typen.executable;
        }
        else if (   ext == ".wav") // kills your ears w/ headphones under mandriva 2005
        {
            return Typen.wave;
        }
        else if (   ext == ""
                 || ext == ".css"
                 || ext == ".dat"
                 || ext == ".db"
                 || ext == ".hm0"
                 || ext == ".hmp"
                 || ext == ".js"
                 || ext == ".stu"
                 || ext == ".zip"
                )
        {
            return Typen.none;
        }
        else
        {
            Console.WriteLine("Ext.Typ '" + ext + "' is not handled (" + path + ").");
            try
			{
				bool bAppend = true;
				StreamWriter sw = new StreamWriter(Var.strPathDat + "/unhandled_datatypes.txt", bAppend, System.Text.Encoding.Default);
				sw.WriteLine(ext + " - " + path);
				sw.Close();
			}
			catch (Exception e) { Console.WriteLine(e.Message); }
            return Typen.unknown;
        }
    }
    
    static Image Typ2Image(Typen typ)
    {
    	// height = 20
    	string img;
    	//if (typ == Typen.album) img = "album";
    	//else if (typ == Typen.audio) img = di.play[3];//"audio";
    	 //if (typ == Typen.broken) img = "broken";
    	 if (typ == Typen.browser) img = "browser";
    	//else if (typ == Typen.executable) img = "executable";
    	//else if (typ == Typen.folder) img = "folder";
    	//else if (typ == Typen.image) img = "image";
    	//else if (typ == Typen.none) img = "unknown";
    	//else if (typ == Typen.text) img = "text";
    	else if (typ == Typen.video) img = "video";
    	// else img = "unknown";
    	else return new Image(Stock.DialogQuestion, IconSize.Menu);
    	return new Image(Var.strPathDat + "/img/" + img + ".png");
    }
    
    internal static Image Typ2StockImage(Typen typ)
    {
    	string stock = "";
    	if (typ == Typen.Album) stock = di.album[3];
    	else if (typ == Typen.audio) stock = di.play[3];
    	else if (typ == Typen.broken) stock = Stock.Delete;
    	else if (typ == Typen.executable) stock = di.exe[3];
    	else if (typ == Typen.folder) stock = di.folder[3];
    	else if (typ == Typen.image) stock = di.image[3];
    	else if (typ == Typen.none) stock = Stock.DialogQuestion;
    	else if (typ == Typen.text) stock = Stock.SelectFont;
    	else return Typ2Image(typ);
    	return new Image(stock, IconSize.Menu);
    }
    
}

