/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;
using System.IO;
using System.Diagnostics;
using System.Threading;

class Input
{
	static bool quit = false;
	static bool show = false;
	
	internal static string lastCmd = "";
	internal static string prompt;
	
	internal static bool Clear(string str)
    {
    	return str == di.clear[0]
    		|| str == di.clear[1]
    		|| str == "clear"
    		|| str == "cls";
    }
    
    internal static void Exec(string cmd)
    {
		Console.WriteLine("cmd='" + cmd + "'");
    	if (cmd == "") return;
		if (cmd == di.play[0]) { Play.Cmd(di.play[0]); lastCmd = cmd;}
		else if (cmd == di.playpause[0]) { Play.Cmd(di.playpause[0]); lastCmd = cmd;}
		else if (cmd.Substring(0, 1) == di.play[0]) Play.Cmd(cmd);
    	else Exec2(cmd);
	}
	
	internal static void Exec2(string cmd)
    {
		string[] acmd;
		acmd = Command.Split(cmd);
		if (Quit(cmd)) quit = true;
		if (Input.Clear(acmd[1]))			{ Output.Clear(); }
		else if (Input.Help(acmd[1]))		{ show = true; }
		else if (acmd[1] == di.db[0])		{ Database.Start(acmd[2]); }
		else if (acmd[1] == di.enq[0])		{ Play.Cmd(di.enq[0] + " " + acmd[2]); }
		else if (acmd[1] == di.gui[0])  	{ Gui.Start(false); }
		// else if (acmd[1] == di.visual[0])  	{ Visual.Start(); }
		else if (acmd[1] == di.voldown[0])	{ Play.Cmd(di.voldown[0] + " " + acmd[2]); lastCmd = cmd; }
		else if (acmd[1] == di.volup[0])		{ Play.Cmd(di.volup[0] + " " + acmd[2]); lastCmd = cmd; }
		else if (acmd[1] != "")
		{
			try { Play.Cmd(Int32.Parse(acmd[1]).ToString()); } 
			catch { show = true; }
		}
    }
    
	internal static string GetLine()
    {
    	return GetLine(string.Empty);
    }
    
	internal static string GetLine(string strText)
    {
		string strPrompt = prompt + ">";
		strText = (strText == "" ? "" : strText + " ");
        return GetLine(strText, strPrompt);
    }
	
	internal static string GetLine(string strText, string strPrompt)
    {
    	Console.Write(strText + strPrompt + " ");
    	string str = di.help[1];
    	try { str = Console.ReadLine(); } catch {} 
        return str;
    }
	
	internal static bool Help(string str)
    {
    	return str == di.help[0]
    		|| str == di.help[1]
    		|| str == "help"
    		|| str == "hilfe";
    }
    
    internal static string LastCmd()
    {
    	return "";
    }
    
    internal static bool Quit(string str)
    {
    	return str == di.quit[0]
    		|| str == "break"
    		|| str == "end"
    		|| str == "exit"
    		|| str == "quit"
    		|| str == "stop"
    		;
    }
	
    internal static void Start(string cmd)
	{
		while (!quit)
		{
			prompt = Var.programNameShort;
			if (show) StartMenu();
			show = false;
			if (cmd == "") cmd = GetLine();
			if (cmd == "") cmd = LastCmd();
			Exec(cmd);
			cmd = "";
		}
	}
	
	static void StartMenu()
	{
		Output.Offer(di.artist);
		Output.Offer(di.clear);
		Output.Offer(di.db);
		Output.Offer(di.enq);
		Output.Offer(di.folder);
		Output.Offer(di.gui);
		Output.Offer(di.help);
		Output.Offer(di.player);
		Output.Offer(di.playpause);
		Output.Offer(di.quit);
		Output.Offer(di.rnd);
		Output.Offer(di.search);
		Output.Offer(di.title);
		// Output.Offer(di.visual);
		Output.Offer(di.voldown);
		Output.Offer(di.volup);
		Output.Offer(di.xrename);
	}
	
}
