/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.IO;
using System.Text.RegularExpressions;

class Lib
{
	public static string[] ExplodeExact(string source, string sep, int length)
	{
		// Gibt ein string[iLength] zurück,
		// damit nicht immer abgefragt werden muss, ob die Length >= ist,
		// bevor eine Aktion durchgeführt wird.
		
		int i;
		string[] astr2 = new string[length];
		for (i = 0; i < length; i++)
		{
			astr2[i] = "";
		}
		string[] astr;
		
		Regex regex = new Regex("(" + sep + ")");
		astr = regex.Split(source);
		i = 0;
		foreach (string str in astr)
		{
			if (i < length && str != sep) astr2[i++] = str;
		}

		// Variante ohne Regex funktioniert nur mit char
		// astr = source.Split(new char[]{sep});
		// i = 0;
		// foreach (string str in astr) { if (i < length) astr2[i++] = str; }
		
		return astr2;
	}

}

