/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.Diagnostics;
using System.IO;

class Lists
{
	internal static void Albums(bool sings)
    {
    	bool bAppend = false;
    	string header = sings ? "sings" : "Alben";
		string file = Var.strPathDat + "/" + header + ".txt";
    	try
    	{
			StreamWriter sw = new StreamWriter(file, bAppend, System.Text.Encoding.Default);
	    	sw.WriteLine(header + " " + DateTime.Now.ToString());
			sw.WriteLine();
			
			MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
			                    "SELECT id,name,path FROM dir order by name");
			if (!m.open) return;
	    	while (m.r.Read()) 
	    	{
	    		string dir = (string)m.r["name"];
	    		sw.WriteLine(dir);
	    		sw.WriteLine("".PadLeft(dir.Length, '-'));
	    		if (sings) sw.WriteLine();
	    		MySql3 m2 = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
	    		                     "SELECT id,name FROM album where dir_id=" + m.r["id"]
	    		                      + " ORDER BY name");
	    		while (m2.r.Read()) 
	    		{
	    			sw.WriteLine(((string)m2.r["name"]).Replace(m.r["path"] + "/", ""));
	    			if (sings) // todo: takes half an eternety
	    			{
	    				MySql3 m3 = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
	    				                     "SELECT name FROM sing where album_id=" + m2.r["id"] + " ORDER by name");
	    				while (m3.r.Read()) sw.WriteLine("- " + ((string)m3.r["name"]).Replace(m2.r["name"] + "/", ""));
	    				m3.Close();
	    				sw.WriteLine();
	    			}
	    		}
	    		m2.Close();
	    		sw.WriteLine();
	    	}
	    	m.Close();
			
			sw.Close();
	    	ProcessStart.Execute(file);
    	} catch {}
    }
    
    internal static void CoversMissingShow(string type)
    {
    	bool bAppend = false;
    	string header = "missing_cover_(";
    	header += (type == "all" ? "all" : "");
    	header += (type == "random" ? "random-relevant" : "");
    	header += (type == "relevant" ? "relevant" : "");
    	header += ")";
		string file = Var.strPathDat + "/" + header + ".txt";
    	try
    	{
			StreamWriter sw = new StreamWriter(file, bAppend, System.Text.Encoding.Default);
	    	sw.WriteLine(header + " " + DateTime.Now.ToString());
			sw.WriteLine();
			//if (all) CoversMissingAll(sw);
			//else CoversMissingRelevant(sw);
			if (type == "all") CoversMissingAll(sw);
			else CoversMissingRelevant(sw, type == "random");
			sw.Close();
	    	ProcessStart.Execute(file);
    	} catch {}
    }
    
    static void CoversMissingAll(StreamWriter sw)
    {
    	MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
    	                    "SELECT path FROM dir");
    	if (!m.open) return;
    	while (m.r.Read()) CoversMissingCheckFolder(sw, m.r["path"].ToString());
    	m.Close();
    }
    
    static void CoversMissingCheckFolder(StreamWriter sw, string dir)
    {
    	try
    	{
    		if (!InOut.SpecialFolder(dir) && !File.Exists(dir + "/" + Img.folder)) sw.WriteLine(dir);
    		foreach (string str in Directory.GetDirectories(dir)) CoversMissingCheckFolder(sw, MySql3.PathTreatment(str));
    	} catch {}
    }
    
    static void CoversMissingRelevant(StreamWriter sw, bool random)
    {
    	string cmd = "SELECT name, path FROM album";
    	if (random) cmd += " WHERE rnd=1";
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, cmd);
    	if (!m.open) return;
    	while (m.r.Read())
    	{
    		if (!File.Exists(m.r["path"].ToString() + "/" + Img.folder)) sw.WriteLine(m.r["name"].ToString());
    	}
    	m.Close();
    }
	
    internal static void SameSize()
    {
    	ArrayList al = new ArrayList();
    	double lastSize = 0;
    	string cmd = "SELECT path, size FROM sing ORDER BY size DESC, path ASC";
    	string file = Var.strPathDat + "/size.txt";
    	File.Delete(file);
    	MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, cmd);
    	if (!m.open) return;
    	while (m.r.Read())
    	{
    		double size = (double)m.r["size"];
    		if (size != lastSize)
    		{
    			if (al.Count > 1)
    			{
	    			Log.Add(file, lastSize.ToString());
	    			foreach (string path in al)
	    			{
	    				Log.Add(file, path);
	    			}
	    			Log.Add(file, "");
    			}
    			lastSize = size;
    			al = new ArrayList();
    		}
    		al.Add(m.r["path"]);
    	}
    	m.Close();
    	ProcessStart.Execute(file);
    }
	
}

