/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;

class MySqlMV
{
	/*
	static string[] tables = new string[]
	{
		"album",
		"random_album",
		"random_sing",
		"setup",
		"sing"
	};
	*/
	
	internal static string ConnectionCheck()
	{
		//string cmd = "show tables";
		//new MySql3("mysql", Mvar.pw, Mvar.server, Mvar.user, cmd);
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "");
		return m.ConnectionCheck();
	}
	
	internal static void CreateDb()
	{
		new MySql3("mysql", Mvar.pw, Mvar.server, Mvar.user,
		           "CREATE DATABASE " + Mvar.db);
		CreateTables();
	}
	/*
	internal static void CreateTableRandomAlbum()
	{
		//new MySql3("CREATE TABLE random_album("
		//	+ "id INT)"); // UNIQUE kann zu Folgefehlern führen
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "CREATE TABLE random_album("
			+ "album_id INT NOT NULL," // PRIMARY KEY AUTO_INCREMENT,"
			+ "dir_id INT NOT NULL,"
			+ "path TEXT NOT NULL"
            + ")");
	}
	
	internal static void CreateTableRandomSing()
	{
		//new MySql3("CREATE TABLE random_sing("
		//    + "id INT)"); // UNIQUE kann zu Folgefehlern führen
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "CREATE TABLE random_sing("
		    + "sing_id INT NOT NULL," // PRIMARY KEY AUTO_INCREMENT,"
			+ "dir_id INT NOT NULL,"
			+ "path TEXT NOT NULL"
            + ")");
	}
	*/
	static void CreateTables()
	{// UNIQUE
		//CreateTableRandomAlbum();
		//CreateTableRandomSing();
		
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "create table album("
			+ "id INT NOT NULL," // PRIMARY KEY AUTO_INCREMENT,"
			+ "dir_id int NOT NULL,"//mediumint unsigned NOT NULL," // id of the add-folder
			+ "audio int NOT NULL," // include in random album
			+ "rnd int NOT NULL," // include in random album
			+ "name TEXT NOT NULL," // full path, peculiars transformed, for search
            + "path TEXT NOT NULL" // full path incl peculiars, immediately playable
            + ")");
		
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "create table dir("
			+ "id int NOT NULL," // primary key auto_increment,"
			+ "albums int NOT NULL,"//mediumint unsigned," // number of folders
			+ "sings int NOT NULL,"// mediumint unsigned," // number of files
			+ "rnd int NOT NULL," // include in random playlist
			+ "changed datetime NOT NULL,"
			+ "name TEXT," // name given by the user
			+ "path TEXT" // UNIQUE" // containing folder
			+ ")");
		
		new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		           "CREATE TABLE sing("
			+ "id int NOT NULL," // primary key auto_increment,"
            + "album_id int NOT NULL," // filtered name of the record
            + "dir_id int NOT NULL,"// mediumint unsigned NOT NULL," // id of the add-folder
            + "rnd int NOT NULL," // include in random playlist
            + "name TEXT NOT NULL," // full path, peculiars transformed, for search
            + "path TEXT NOT NULL," // full path incl peculiars, immediately playable
            + "size DOUBLE NOT NULL," // full path incl peculiars, immediately playable
            + "type TEXT NOT NULL" // mediatype
            + ")");
	}
	
	/*
	internal static void DropTables(ref MySqlSource ms)
	{
		foreach (string table in tables)
		{
			ms.Add("DROP TABLE IF EXISTS " + table);
		}
	}
	*/
}
