/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using System;

class Output
{
	internal static void Clear()
	{
		for (int i = 0; i < 60; i++) Console.WriteLine("");
	}
	
    internal static void Header(bool bTwoLines, string str)
    {
        if (bTwoLines) Line(str);
        Console.WriteLine(str);
		Line(str);
	}
    
    internal static void Info(string message)
	{
		Output.Message(message, "info");
	}
	
	internal static void Line(string str)
	{
		string strLine = string.Empty;
		for (int i = 0; i < str.Length; i++)
		{
			strLine += "*";
		}
		Console.WriteLine(strLine);
	}
    
	internal static void Message(string message)
	{
		Output.Message(message, string.Empty);
	}
    
	internal static void Message(string message, string title)
	{
		try { Gui.gui.Message(title + "\n\n" + message); }
		catch { Message2Console(message, title); }
	}
	
	static void Message2Console(string message, string title)
	{
		Console.WriteLine(title + ": " + message);
	}
    
	internal static void Offer(string[] astr)
	{
		Offer(astr, Var.sepOffer);
	}
	
	static void Offer(string[] astr, string sep)
	{
		Console.WriteLine(astr[0] + sep + astr[1]);
	}
	
	internal static void Offer2(string[] astr)
	{
		Offer(astr, "\t");
	}
	
	internal static void OfferOption(string[] astr)
	{
		Console.WriteLine("-" + astr[0] + Var.sepOffer + astr[1]);
	}
	
	internal static void Text(string str)
	{
		Console.WriteLine(str);
		return;
	}
	
}
