/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Diagnostics;
using System.Collections;
using System.IO;

class Player
{
	internal static void TestQuark()
	{
		string[] astr = new string[]
		{
			"﻿/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/01 offenes_ende.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/02 das_absolute_glueck.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/03 wettentspannen.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/04 es_bleibt_uns_der_wind_(du_bist_richtig_hier).mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/05 gerader_weg.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/06 benimmunterricht_(das_arbeitgeberpraesident).mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/07 lied_vom_ende_des_kapitalismus.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/08 hallo_hallo_(dies_ist_der_tag).mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/09 wir_werden_siegen.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/10 der_boese_mann.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/11 kopf_zwischen_sterne.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/12 unsere_zeit.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/13 du_kommst_nicht_mehr_zurueck.mp3",
			"/media/K/Great/Peter Licht_-_Lieder_Vom_Ende_Des_Kapitalismus (2006)/14 das_abslolute_glueck_(alberto_hauss_glueckskeks_rmx).mp3",
		};
		try
		{
			for (int i = 0; i < 1; i++)//;string str in astr)
			{
				
				string c = "charm-quark replace \"" + astr[i] + "\"";
				Console.WriteLine(c);
				Process.Start(c);
			}
		}
		catch (Exception e) { Console.WriteLine(e.Message); }
	}
	internal static void TestXmms()
	{
		string c = "xmms2-launcher";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
		
		try
		{
			c = "xmms2 list";
			Console.WriteLine(c);
			Process.Start(c);
			
			c = "xmms2 add \"file:///mischa/home/test.mp3\"";
			Console.WriteLine(c);
			Process.Start(c);
			
			c = "xmms2 add \"file:///mischa/home/test2.mp3\"";
			Console.WriteLine(c);
			Process.Start(c);
			
			c = "xmms2 list";
			Console.WriteLine(c);
			Process.Start(c);
			
			
			
		} catch (Exception e) { Console.WriteLine(e.Message); }
		
	}
	internal ArrayList alCmd;
	internal ArrayList alId = new ArrayList();
	static int player = Ini.GetInt("Player");//SysInfo.Unix ? 0 : 1;
	internal string opt = "";
	internal string program;
	
	//               *******     *****                         *****
	static string[] aProgram = {"", "totem", Ini.GetString("WinAmpCLAmp"), "amarok", "charm-quark", "xmms2"};
	//               *******     *****                         *****
	static string[] enqueue = {"", "--enqueue", "/PLADD", "--append", "append", ""};
	// static string[] load = {"", "", "", "--load", "", ""}; // load URLs, replacing current playlist
	static string[] next = {"", "--next", "/NEXT", "--next", "next", ""};
	//static string[] replay = {"", "--play-pause", "/PLAY", "", "", ""};
	static string[] play = {"", "--play", "/PLAY", "--play-pause", "replace", "play"};
	static string[] playpause = {"", "--play-pause", "/PLAYPAUSE", "--play-pause", "pause", ""};
	static string[] previous = {"", "--previous", "/PREV", "--previous", "prev", ""};
	static string[] seekbwd = {"", "--seek-bwd", "/REW", "", "", ""};
	static string[] seekfwd = {"", "--seek-fwd", "/FWD", "", "", ""};
	// static string[] stop = {"", "", "", "--stop", "stop", ""};
	internal static string[] voldown = {"", "--volume-down", "/VOLDN", "", "", ""};
	internal static string[] volup = {"", "--volume-up", "/VOLUP", "", "", ""};
	//        *******     *****                 *****
	
    internal Player(string cmd)
    {
    	program = aProgram[player];
    	if (cmd == di.play[0]) { opt = play[player]; }
        else if (cmd == di.playpause[0]) { opt = playpause[player]; }
        alCmd = Command.ToParam(cmd);
        foreach (string str in alCmd)
        {
        	try { alId.Add(Int32.Parse(str)); }
        	catch { if (opt == "") Option(str); }
        }
        ProcessStart();
    }
    
    internal static void CreatePlaylistFromArrayListPath(ArrayList alPath, bool enq)
	{
    	string file = SysInfo.PathTreatment(GetTempFileName("rnd"));
		
		Console.WriteLine(file);
    	InOut.ArrayList2File(alPath, file);//, System.Text.Encoding.ASCII);
    	Player.PlayFile(enq, file);
	}
    
    internal static void CreatePlaylistFromArrayListPath(ArrayList alPath, bool enq, int start, int end)
    {
    	ArrayList al = new ArrayList();
    	for (int i = start; i < end; i++) al.Add((string)alPath[i]);
    	CreatePlaylistFromArrayListPath(al, enq);
    }
    
    static void CreatePlaylistFromFolder(bool enq, bool processStart, string dir)
    {
		Console.WriteLine("Player.CreatePlaylistFromFolder");
		Console.WriteLine("System.Text.Encoding.Default: " + System.Text.Encoding.Default);
    	ArrayList al = FolderToArrayListAudioSorted(dir);
    	string file = GetTempFileName("album");
    	InOut.ArrayList2File(al, file);//, System.Text.Encoding.Default);//ASCII);
    	if (processStart) PlayFile(enq, file);
    }
    
    static ArrayList FolderToArrayListAudioSorted(string dir)
    {
    	ArrayList al = new ArrayList();
    	string[] astr = Directory.GetFiles(dir);
    	for (int i = 0; i < astr.Length; i++)
    	{
    		if (Ext.Path2Typ(astr[i]) == Ext.Typen.audio) 
    		{
    			al.Add(astr[i]);
    		}
    	}
    	al.Sort();
    	return al;
    }
    
    static string GetTempFileName(string type)
    {
    	// return Ini.GetString("DirTemp") + "/" + Kalender.DateTimeToFileStamp(DateTime.Now) + "_" + type + ".m3u";
		// Path.GetTempFileName;
		return Var.strPathTemp + Kalender.DateTimeToFileStamp(DateTime.Now) + "_" + type + ".m3u";
    }
    
    void Option(string str)
    {
    	if (str == di.enq[0])		{ opt = enqueue[player]; return; }
    	if (str == di.playnext[0])	{ opt = next[player]; return; }
    	if (str == di.playprev[0])	{ opt = previous[player]; return; }
    	if (str == di.seekbwd[0])	{ opt = seekbwd[player]; return; }
    	if (str == di.seekfwd[0])	{ opt = seekfwd[player]; return; }
    	if (str == di.voldown[0])	{ opt = Volume.Adjust(voldown[player]); return; }
    	if (str == di.volup[0])		{ opt = Volume.Adjust(volup[player]); return; }
    }
    
    internal static void PlayFile(bool enq, string file)
    {
    	PlayFiles(enq, "\"" + file + "\"");
    }
    
    internal static void PlayFiles(bool enq, string file)
    {
		Console.WriteLine("Player.PlayFiles enq=" + enq);
    	Console.WriteLine("Player.PlayFiles file=" + file);
    	string program = aProgram[player];
    	if (!SysInfo.Unix)
    	{
    		file = file.Replace('/', '\\');
    		if (!enq) program = Ini.GetString("AudioProgramPlay");
		}
    	try
    	{
    		//Process.Start(program, (enq ? (enqueue[player] + " ") : "") + file);
			if (enq) Process.Start(program, enqueue[player] + " " + file);
			else
			{
				//if (load[player] != "") Process.Start(program, stop[player]);
				
				// für Amarok evtl. play[player] hinzufügen
				//Process.Start(program, (load[player] == "" ? "" : (load[player] + " ")) + file);
				Process.Start(program, play[player] + " " + file);
				//if (load[player] != "") Process.Start(program, play[player]);
			}
    	}
    	catch (System.ComponentModel.Win32Exception)
    	{
    		Error.Message("player cannot be started"); 
    	}
    }
    
    internal static void PlayFolder(bool enq, string dir)
    {
    	//if (SysInfo.Unix) PlayFolderOneByOne(enq, true, dir);
    	CreatePlaylistFromFolder(enq, true, dir);
    }
    
    void ProcessStart()
    {
    	if (alId.Count == 0) ProcessStartControl();
    	else ProcessStartFile();
    }
    
    void ProcessStartControl()
    {
    	if (opt != "") Process.Start(program, opt);
    }
	
    void ProcessStartFile()
    {
    	foreach (int id in alId)
    	{
    		Sing sing = new Sing(id);
    		if (sing.exists)
    		{
	        	string file = sing.path;
	        	if (!SysInfo.Unix)
	        	{
	        		file = file.Replace('/', '\\');
					if (opt == "") program = "C:\\Programme\\Winamp\\winamp.exe";
				}
					
	        	string str = opt + (opt == "" ? "" : " ");
	        	str += (file == "" ? "" : "\"" + file + "\"");
	        	try { Process.Start(program, str); }
	        	catch (System.ComponentModel.Win32Exception)
	        	{ Error.Message("player cannot be found"); }
    		}
    	}
    }
	
	
	internal static void TestTotem()
	{
		string[] astr = new string[]
		{
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/01 The Shining.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/02 Everybodys Stalking.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/03 Bewilder.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/04 Fall In A River.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/05 Camping Next To Water.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/06 Stone On The Water.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/07 Another Pearl.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/08 Body Rap.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/09 Once Around The Block.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/10 This Song.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/11 Bewilderbeast.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/12 Magic In The Air.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/13 Cause A Rockslide.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/14 Pissing In The Wind.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/15 Blistered Heart.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/16 Disillusion.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/17 Say It Again.mp3",
			"/home/mischa/test/Badly Drawn Boy/(2001) The Hour Of Bewilderbeast/18 Epitaph.mp3"
		};
		
		string program = aProgram[player];
		
		Console.WriteLine("playing " + astr[0]);
		// PlayFile(false, astr[0]);
		try
    	{
    		//Process p = Process.Start(program, (enq ? (enqueue[player] + " ") : "") + "\"" + astr[0] + "\"");
    		//int c = 0;
    		//while (!p.Responding)
    		//{
    		//	Console.WriteLine("p.Responding: " + p.Responding + " " + (++c));
    		//}
    		
    		ProcessStartInfo psi = new ProcessStartInfo();
    		psi.Arguments = "\"" + astr[0] + "\"";
    		psi.FileName = program;
    		
    		//Console.WriteLine(DateTime.Now.ToString());
    		Process p = Process.Start(psi);
    		
    		//object o = p.GetLifetimeService();
    		//Console.WriteLine(o.ToString());
    		//p.Handle();
    		// p.WaitForExit();
    		/*
    		ProcessThreadCollection a = p.Threads;
    		foreach (object o in a)
    		{
    			Console.WriteLine(o.ToString());
    		}
    		*/
    		//Console.WriteLine(DateTime.Now.ToString());
    		
    		//Console.WriteLine("p.Id:" + p.Id);
    		//Console.WriteLine("p.StartTime:" + p.StartTime);
    		
    		//Console.WriteLine("psi.ExitCode: " + psi.ExitCode + " (0=ok)");
    		
    		
    		for (int i = 1; i < astr.Length; i++)
			{
				Console.WriteLine("press enter for next enq");
				Console.ReadLine();
				Console.WriteLine("enq " + astr[i]);
				psi.Arguments = enqueue[player] + " \"" + astr[i] + "\"";
				p.StartInfo = psi;
				p.Start();
    			Console.WriteLine("p.Id:" + p.Id);
    			Console.WriteLine("p.StartTime:" + p.StartTime);
			}
    		
    		
    		/*
    		Console.WriteLine("press enter to kill");
    		Console.ReadLine();
    		p.Kill();
    		Console.WriteLine("killed");
    		Console.ReadLine();
    		*/
    	}
    	catch (System.ComponentModel.Win32Exception)
    	{
    		Console.WriteLine("song cannot be played"); 
    	}
    	
    	/*
		for (int i = 1; i < astr.Length; i++)
		{
			Console.WriteLine("press enter for next enq");
			Console.ReadLine();
			Console.WriteLine("enq " + astr[i]);
			PlayFile(true, astr[i]);
		}
		*/
		
		
		
	}
    
}
/* Amarok

  -r, --previous            Skip backwards in playlist
  -p, --play                Start playing current playlist
  -t, --play-pause          Play if stopped, pause if playing
  --pause                   Pause playback
  -s, --stop                Stop playback
  -f, --next                Skip forwards in playlist

Additional options:
  -a, --append              Append files/URLs to playlist
  -e, --enqueue             See append, available for backwards compatability
  --queue                   Queue URLs after the currently playing track
  -l, --load                Load URLs, replacing current playlist
  -m, --toggle-playlist-window Toggle the Playlist-window
  --wizard                  Run first-run wizard
  --engine <name>           Use the <name> engine
  --cwd <directory>         Base for relative filenames/URLs
  --cdplay <device>         Play an AudioCD from <device>
*/



/* man totem

NAME 
totem - GNOME-desktop movie player based on the xine backend
SYNOPSIS 
totem [option...] [filenames|URI]
DESCRIPTION 
totem is a movie player for the GNOME desktop. Through use of the xine backend many popular file and streaming formats are supported including: MPEG audio and video (MP3/MPV), Ogg, AVI, ASF, MOV, WMV, Quicktime, and more. Playing of DVD and VCD media is usually possible if you have the appropriate drive. Although primarily intended as a movie player, totem can also play many audio formats. For additional documentation on interactive use of totem select the Help menu option. The menus allow access to some features not available through keybindings or command-line options.
OPTIONS 

--usage
    Output a brief synopsis of command options then quit. 
-?, --help
    Output a longer help message then quit. (Any discrepancies between this man page and the output of totem --help should be reported as a documentation bug.) 
--version
    Output version information then quit. The following options command an already running instance of totem to do something; they are useful for remote-control scripting: 
--play-pause
    Tell an already running instance of totem to toggle between play and pause. 
--next
    Tell an already running instance of totem to skip to the next movie or chapter in the playlist. 
--previous
    Tell an already running instance of totem to return to the previous movie or chapter in the playlist. 
--seek-fwd
    Tell an already running instance of totem to seek forwards 15 seconds in the current movie. 
--seek-bwd
    Tell an already running instance of totem to seek backwards 15 seconds in the current movie. 
--volume-up
    Tell an already running instance of totem to raise the volume by 8%. 
--volume-down
    Tell an already running instance of totem to lower the volume by 8%. 
--fullscreen
    Tell an already running instance of totem to toggle fullscreen mode. 
--quit
    Tell an already running instance of totem to quit. 
--enqueue filename|URI
    Tell an already running instance of totem to add a new stream to the playlist. 
--replace filename|URI
    Tell an already running instance of totem to play from the playlist. 

The following options are standard to applications using the GDK and GTK+ libraries: 

--gdk-debug=flags
    GDK debugging flags to set. 
--gdk-no-debug=flags
    GDK debugging flags to unset. 
--display=display
    X display to use 
--screen=screen
    X screen to use. 
--sync
    Make X calls synchronous to facilitate debugging. 
--name=name
    Program name as used by the window manager. 
--class=class
    Program class as used by the window manager. 
--gxid-host=host
--gxid-port=port
--g-fatal-warnings
    Make all warnings fatal. 
--gtk-debug=flags
    GTK+ debugging flags to set. 
--gtk-no-debug=flags
    GTK+ debugging flags to unset 
--gtk-module=module
    Load an additonal GTK module. The following options are for Bonobo activation support 
--oaf-ior-fd=fd
    File descriptor to print IOR on 
--oaf-activate-iid=iid
    IID to activate. 
--oaf-private
    Prevent registering of server with OAF 

The following are standard GNOME options:
 
--disable-sound
    Disable sound server use. 
--enable-sound
    Enable sound server use. 
--espeaker=hostname:port
    Specify the host and port on which the sound server is listening. 
--disable-crash-dialog
    Disable the crash-reporting dialog.

The following options are for session management:
 
--sm-client-id=ID
    Specify session management ID 
--sm-config-prefix=prefix
    Specify prefix of saved configuration 
--sm-disable
    Disable connecting to session manager.

KEYBINDINGS 
Global keybindings for totem: 
	i	toggle interlacing on and off
	p	toggle between play and pause
	Esc exit full screen mode
	f	toggle full screen
	h	toggle display of on-screen controls
	0	resize window to 50% original size 
	1	resize window to 100% original size 
	2	resize window to 200% original size 
	Left-arrow	skip back 15 seconds 
	Right-arrow	skip forward 15 seconds
	Up-arrow	increase volume by 8%
	Down-arrow	decrease volume by 8% 
	b	jump back to previous chapter/movie in playlist
	n	jump to next chapter/movie in playlist
	q	quit
	s	show the "skip to" dialog
	Ctrl-O	open a new file
	Ctrl-L	open a new URI
	Ctrl-P	toggle display of the playlist 
	m	show the DVD menu 
	c	show the DVD chapter menu

BUGS 
totem cannot play files using some proprietary codecs.
AUTHOR 
totem was written by Bastien Nocera <hadess@hadess.net>. This manual page was written by Andre Lehovich for the Debian Project.
DISTRIBUTION 
The latest version of Totem may be downloaded from <http://www.hadess.net/totem.php3>
SEE ALSO 
totem-video-thumbnailer(1), xine(1) The online documentation available through the program's Help menu.

*/



/* CLAmp /?

CLAMP - Command Line Winamp - Version 0.0.5
http://membres.lycos.fr/clamp/
tools@caramail.com

Program Control
---------------
/START ............ Start Winamp
/QUIT ............. Exit Winamp

General Control
---------------
/PLAY ............. Play (current file) - Quits Stopped or Pause mode
/STOP ............. Stop playing
/STOPFADE.......... Stop playing with fadeout
/PAUSE ............ Toggle pause mode (Synonym: /PLAYPAUSE)
/NEXT ............. Play next song
/PREV ............. Play previous song
/FWD .............. Forward 5 seconds (Synonym: /FORWARD)
/REW .............. Rewind 5 seconds (Synonym: /REWIND)

Winamp Modes
------------
/REPEAT ........... Toggle repeat mode (Synonym: /SWREPEAT)
/REPEAT ON|OFF .... Set repeat ON or OFF (Same as /REPEAT=0 or /REPEAT=1)
/RANDOM ........... Toggle random mode
/RANDOM ON|OFF .... Set random ON or OFF (Same as /RANDOM=0 or /RANDOM=1)

PlayList Control
----------------
/PLADD <file> ..... Add file at end of playlist (Synonym: /LOAD)
/PLCLEAR .......... Clear Playlist (Synonym: /CLEAR)
/PLWIN ............ Show/Hide PlayList window
/PLPOS ............ Query Playlist position
/LOADNEW <file> ... Same as /PLCLEAR /PLADD <file>
/PLFIRST .......... Play first item of playlist
/PLLAST ........... Play last item of playlist

Volume Control
--------------
/VOLUP ............ Volume up
/VOLDN ............ Volume down (Synonym: /VOLDOWN)
/VOLMAX ........... Volume to maximum
/VOLMIN ........... Volume off (Synonym: /VOLOFF)
/VOLSET <value> ... Volume set (0-255 / MIN / MAX / OFF) (Synonym: /VOLUME)

Infos
-----
/POS .............. Query current position in file / Total Length
/POSITION ......... Query current position in file
/TITLE ............ Query current track title
/STATE ............ Query current state (PLAYING;PAUSED;STOPPED;NOT RUNNING)
/STATUS ........... Synonym for STATE
/VER .............. Prints WinAmp version

Winamp interactive windows
--------------------------
/ABOUT ............ Open Winamp About window
/PREFS ............ Open Winamp Preferences window
/OPEN ............. Open Winamp Open File window

Equalizer control
-----------------
/EQWIN ............ Show/Hide Eq window (Works with Classic skins only)
/EQINFO ........... Query Eq parameters (10 bands, Preamp, Status, Autoload)
/EQSET <parms> .... Set Eq parameters (Same format as EQINFO)
/EQSTATUS ......... Toggle Eq status (ON / OFF)
/EQSTATUS ON|OFF .. Set Eq ON or OFF

Winamp display
--------------
/ONTOP ............ Toggle "Always On Top" Option
/MAINWIN .......... Toggle Main window
/MINIMIZE ......... Minimize window

Misc
----
/CDPLAY ........... Play CD

*/
