/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.IO;

class Rename
{
    static internal string Folder(string source, string dest)
    {
    	string error = "";
    	try
		{
			if (Directory.Exists(dest)) return "folder exists\n";
			Directory.CreateDirectory(dest);
			foreach (string str in Directory.GetFiles(source))
			{
				if (error == "")
				{
					string source2 = MySql3.PathTreatment(str);
					string dest2 = dest + "/" + Path.GetFileName(source2);
					Console.WriteLine(source2);
					Console.WriteLine(dest2);
					error += Sing(source2, dest2);
				}
			}
			foreach (string str in Directory.GetDirectories(source))
			{
				if (error == "")
				{
					string source2 = MySql3.PathTreatment(str);
					string dest2 = dest + "/" + Path.GetFileName(source2);
					Console.WriteLine(source2);
					Console.WriteLine(dest2);
					error += Folder(source2, dest2);
				}
			}
			if (error == "") Directory.Delete(source);
		}
		catch (Exception e)
		{
			error += e.Message + "\n";
		}
		if (error != "") return error;
		Album album = new Album(source);
		Console.WriteLine("exists=" + album.exists);
		Console.WriteLine("source " + source);
		Console.WriteLine("dest   " + dest);
		Console.WriteLine("");
		
		return album.exists ? album.Update(dest) : "";
    }
    
    static string MoveFile(string source, string dest)
    {
		string error = "";
		try
		{
			if (File.Exists(dest)) return "file exists";
			File.Move(source, dest);
		}
		catch (Exception e)
		{
			error += e.Message + "\n";
		}
		return error;
    }
    
    static internal string Sing(string source, string dest)
    {
    	string error = MoveFile(source, dest);
		if (error != "") return error;
		Sing sing = new Sing(source);
		return sing.exists ? sing.Update(dest) : "";
    }
    
}

