/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.IO;

class Rnd
{
	ArrayList al = new ArrayList();
	internal ArrayList alPath = new ArrayList();
	bool album;
	int haystack;
	int limit;
	Random random = new Random();
	string search;
	
	internal Rnd(bool album, int limit)
	{
		Benchmark b = new Benchmark();
		this.album = album;
		haystack = Haystack(album);
		if (limit > haystack) limit = haystack;
		while (al.Count < limit)
		{
    		int r = random.Next(haystack);
    		if (!al.Contains(r)) al.Add(r);
		}
    	if (album) alPath = ArrayListPath();
		else Console.WriteLine("Rnd(2) not prepared for sing");
		b.Stop();
		Console.WriteLine(b.Details(true));
		
		Gui.gui.pc.TestLabel(3, b.Details(true));
	}
    
	internal Rnd(bool album, bool enq, int limit)
	{
		Console.WriteLine("Rnd(bool, bool, int)");
		//bool playFirst = !enq && !album;
		// Gui.gui.GdkWindow.Cursor = new Gdk.Cursor(Gdk.CursorType.Watch);
		Benchmark b = new Benchmark();
		this.album = album;
		haystack = Haystack(album);
		Console.WriteLine("haystack=" + haystack);
		if (limit > haystack) limit = haystack;
		while (al.Count < limit)
		{
    		int r = random.Next(haystack);
    		if (!al.Contains(r))
    		{
    			al.Add(r);
    			
    		//if (playFirst && al.Count == 1)
    		//{
    			// idealfall play here
    			
    			// disadvantage: Windows player mixes it up, does not compare to the quizform anymore
    			//ArrayList temp = ArrayListPath();
    			
    			//string str = ArrayListPathGetOne((int)al[al.Count-1]);
    			//if (!enq)
    			//{
    				
    			//	Player.PlayFile(enq, str);
    			//	Console.WriteLine("first: " + al[0] + " / " + str);
    			//	enq = true;
    			//}
    			//alPath.Add(str); // might not work with other players (play first song above and adding it to the playlist to be enqueued 
    			
    		}
		}
		if (album)
		{
			if (al.Count == 1)
			{
				int id = GetIdFromEntry(album, al[0]);
				alPath = Album.Id2SingArrayListPaths(id);
			}
		}
		else
		{
			alPath = ArrayListPath();// file:///media/K/m/Box2/DIVERSE/Gay%20Dad%20-%20Joy!%20(1999)/03%20Sly.mp3
		}
		b.Stop();
		Console.WriteLine(b.Details(true));
		Gui.gui.pc.TestLabel(3, b.Details(true));
	}
	
	internal Rnd(bool album, bool enq, int limit, string search)
	{
		Benchmark b = new Benchmark();
		this.album = album;
		this.limit = limit;
		this.search = search;
		if (album) 
		{
			RndSearchStartAlbum();
			if (al.Count == 1) alPath = Album.Id2SingArrayListPaths((int)al[0]);
		}
		else RndSearchStartSing();
		b.Stop();
		Console.WriteLine(b.Details(true));
		Gui.gui.pc.TestLabel(3, b.Details(true));
	}
	
	void RndSearchStartAlbum()
	{
		ArrayList alAll = new ArrayList();
		Mvar.moc.ExecReader("SELECT id FROM album"
		                    + " WHERE " + Search.SearchStringToQuery("name", search)
		                    + " AND audio=1");
		while (Mvar.moc.r.Read()) alAll.Add((int)Mvar.moc.r["id"]);
		Mvar.moc.CloseReader();
		
		int haystack = alAll.Count;
		if (haystack > 0) haystack++;
		if (limit > haystack) limit = haystack;
		if (limit == 0) return;
		while (al.Count < limit)
    	{
			if (haystack == 0) return;
			int r = random.Next(haystack);
			al.Add((int)alAll[r]);
			alAll.RemoveAt(r);
			haystack--;
		}
	}
	
	void RndSearchStartSing()
	{
		ArrayList alAll = new ArrayList();
		Mvar.moc.ExecReader("SELECT path FROM sing"
		                    + " WHERE " + Search.SearchStringToQuery("name", search)
		                    + " AND type='audio'");
		while (Mvar.moc.r.Read()) alAll.Add((string)Mvar.moc.r["path"]);
		Mvar.moc.CloseReader();
		
		int haystack = alAll.Count;
		if (limit > haystack) limit = haystack;
		if (limit == 0) return;
		
		while (alPath.Count < limit && haystack > 0)
    	{
			int r = random.Next(haystack--);
			alPath.Add((string)alAll[r]);
			alAll.RemoveAt(r);
		}
	}
	
	// ############
	// # Routinen #
	// ############
	
	ArrayList ArrayListPath()
	{
		ArrayList temp = new ArrayList();
		for (int i = 0; i < al.Count; i++) temp.Add(ArrayListPathGetOne((int)al[i]));
    	return temp;
	}
	
	string ArrayListPathGetOne(int limit)
	{
		string str = "";
		Mvar.moc.ExecReader("SELECT path FROM " + (album ? "album" : "sing") + " WHERE rnd=1 LIMIT " + limit + ",1");
		if (Mvar.moc.r.Read()) str = (string)Mvar.moc.r["path"];
		Mvar.moc.CloseReader();
		return str;
	}
	
	internal static bool Check(ref string name)
    {
		bool rnd = true;
		int no = name.LastIndexOf(Var.rndNo);
        int yes = name.LastIndexOf(Var.rndYes);
        if (no == yes) return rnd;
        if (no > yes) rnd = false;
		name = name.Replace(Var.rndNo, "");
		name = name.Replace(Var.rndYes, "");
		name = name.Replace(" /", "/");
		name = name.Replace("  ", " ");
		name = name.Trim();
		string ext = Path.GetExtension(name);
		if (ext != "") name = name.Replace(" " + ext, ext);
		return rnd;
    }
	
	static int GetIdFromEntry(bool album, object entry)
	{
		string table = album ? "album" : "sing";
		Mvar.moc.ExecReader("SELECT id FROM " + table + " WHERE rnd=1 LIMIT " + entry + ",1");
		if (!Mvar.moc.r.Read()) return 0;
		int i = (int)Mvar.moc.r[0];
		Mvar.moc.CloseReader();
		return i;
	}
	
	static int Haystack(bool album)
	{
		Mvar.moc.ExecReader("SELECT COUNT(id) FROM " + (album ? "album" : "sing") + " WHERE rnd=1");
		if (!Mvar.moc.r.Read()) return 0;
		int i = Int32.Parse(Mvar.moc.r[0].ToString());
		Mvar.moc.CloseReader();
		return i + 1; // add 1 because random.Next(i) gives values between >= 0 and < COUNT(id), but not COUNT(id) itself
	}
	
}
 
