/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;

class Selection
{
	static ArrayList albums = new ArrayList();
	static ArrayList sings = new ArrayList();
	static int lastId = 0;
    static List.Type lastType = List.Type.sing;
	
    internal static int LastId { get { return lastId; } }
    internal static List.Type LastType { get { return lastType; } }
    
    internal static void Clear()
	{
		albums.Clear();
		sings.Clear();
	}
	
	internal static bool Contains(List.Type type, int id)
	{
		return (GetArrayList(type).Contains(id));
	}
	
	internal static ArrayList GetArrayList(List.Type type)
	{
		switch (type)
		{
			case List.Type.album : return albums;
			default : return sings;
		}
	}
	
	internal static ArrayList GetArrayListAlbumIdFromLastSelectedItem(
	                          	bool removeFromSelection)
	{
		ArrayList al = new ArrayList();
		if (lastType == List.Type.album)
		{
			if (albums.Count > 0) al.Add(albums[0]);
		}
		else if (lastType == List.Type.sing)
		{
			Sing sing = new Sing(lastId);
			al.Add(sing.album_id);
		}
		else 
		{
			return al;
		}
		if (removeFromSelection) Toggle(lastType, false, lastId);
		return al;
	}
	
	internal static void PlaySelection(List.Type type, bool enq)
    {
		foreach (int id in Selection.sings)
		{
    		Play.OneSing(enq, id);
    		enq = true;
    	}
		foreach (int id in Selection.albums)
    	{
    		Play.OneAlbum(enq, id);
    		enq = true;
    	}
		Clear();
    }
    
	internal static void Toggle(List.Type type, bool active, int id)
	{
		ArrayList al = GetArrayList(type);
		if (active)
		{
			if (!al.Contains(id)) al.Add(id);
		}
		else
		{
			al.Remove(id);
		}
		if (active)
		{
			lastId = id;
			lastType = type;
		}
    }
	
}

