/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using MiBib;
using System;
using System.Collections;
using System.IO;

internal class Sing
{
	internal bool exists = false;
	internal bool rnd;
    internal int album_id;
    internal int dir_id;
	internal int id = 0;
	internal double size = 0;
	internal string path = "";
	internal string name = "";
	internal static string sequence = di.artist[0] + di.title[0] + di.folder[0];
	internal string type = "";
	
    internal Sing() { }
    
    internal Sing(int id) { Load("id", id.ToString()); }
    
    internal Sing(string path) { Load("path", path); }
    
    internal void Create(string path) { UpdateFromPath(path); }
    
    internal void Create(string path, Album album, ref int[] max_ids)
    {
    	album_id = album.id;
    	dir_id = album.dir_id;
    	
    	max_ids[2]++;
    	id = max_ids[2];
    	
    	UpdateFromPath(path);
    }
    
    internal string Folder { get { return MySql3.PathTreatment(Path.GetDirectoryName(path)); } }
	
	internal string Details()
    {
    	return "track " + id
    		+ "\"\n" + di.rnd[1] + ":\t\"" + rnd
			+ "\"\n" + "path" + ":\t\"" + path
			+ "\"\n" + "name" + ":\t\"" + name
			+ "\"";
	}
	
	internal string Directory(int i) { return Dir.Directory(path, i); }
	
	void Load(string column, string cellValue)
	{
		MySql3 m = new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user,
		                    "SELECT album_id,dir_id,id,name,path,rnd,type FROM sing WHERE "
    	                    + column + "=\"" + cellValue + "\"");
		if (!m.open) return;
		if (m.r.Read())
		{
			album_id = (int)m.r["album_id"];
			dir_id = (int)m.r["dir_id"];
			exists = true;
			id = (int)m.r["id"];
			name = (string)m.r["name"];
			path = (string)m.r["path"];
			rnd = m.r["rnd"].ToString() == "1";
			type = (string)m.r["type"];
		}
		m.Close();
	}
	
	string Save()
	{
		return " sing set "
			+ "album_id=" + album_id + ","
			+ "dir_id=" + dir_id + ","
			+ "name=\"" + name + "\","
			+ "path=\"" + path + "\","
			+ "rnd=" + (rnd ? "1" : "0") + ","
			+ "size=" + size + ","
			+ "type=\"" + type + "\""
			;
	}
    /*
	internal static string SaveCollection(ref ArrayList al)
	{
		if (al.Count == 0) return "";
		Console.Write(".");
		Sing sing = (Sing)al[0];
		string cmd = "INSERT INTO sing(album_id,dir_id,name,path,rnd,size,type) VALUES(" 
			+ SaveCollectionPart(sing) + ")";
    	for (int i = 1; i < al.Count; i++)
    	{
    		sing = (Sing)al[i];
    		cmd += ",(" + SaveCollectionPart(sing) + ")";
    	}
    	al = new ArrayList();
    	return MySqlB.Exec(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, cmd);
	}
	*/
	/*
	static string SaveCollectionPart(Sing sing)
	{
		return "" + sing.album_id + "," + sing.dir_id + ",\"" + sing.name + "\",\"" + sing.path + "\"," + (sing.rnd ? 1 : 0) + "," + sing.size + ",\"" + sing.type + "\"";
	}
	*/
	internal string SaveInsertQuery()
	{
		return "INSERT INTO sing VALUES("
			+ id + ","
			+ album_id + ","
			+ dir_id + ","
			+ (rnd ? 1 : 0) + ","
			+ "\"" + name + "\","
			+ "\"" + path + "\","
			+ 0 + ","
			+ "\"" + type + "\""
			+ ");"
			;
	}
	/*
	internal string SaveInsertQueryRandom()//ref int[] max_ids)
	{
		//max_ids[4]++;
		return "INSERT INTO random_sing VALUES("
			//+ max_ids[4] + ","
			+ id + ","
			+ dir_id + ","
			+ "\"" + path + "\""
			+ ");"
			;
	}
	*/
	string SaveUpdate()
    {
    	new MySql3(Mvar.db, Mvar.pw, Mvar.server, Mvar.user, "update" + Save() + " WHERE id=" + id);
    	return "";
    }
	
	internal string Update(string path)
    {
    	UpdateFromPath(path);
    	return SaveUpdate();
    }
	
    void UpdateFromPath(string path)
    {
    	this.path = path;
    	name = Peculiar.Substitute(path);
    	Ext.Typen typ = Ext.Path2Typ(path);
    	if (typ == Ext.Typen.audio) rnd = Rnd.Check(ref name);
    	else rnd = false;
    	type = typ.ToString();
    	// try { size = new FileInfo(path).Length; } 
    	// catch { Console.WriteLine("not found: " + path); }
    }
	
	internal void WriteLine(string sequence)
	{
    	string str = "";
    	if (sequence == di.details[0]) sequence = "iatf";
    	char[] ach = sequence.ToCharArray();
    	for (int i = 0; i < ach.Length; i++)
    	{
    		string opt = ach[i].ToString().ToLower();
    		if (opt == di.index[0]) str += id;
    		else Error.Message("Sing.WriteLine cannot cope w/ '" + opt + "'");
    		
    		string separator = Var.sepOutput;
    		if (i == 0 && opt == di.index[0]) separator = "\t";
    		else if (opt == di.track[0]) separator = " ";
    		else if (i == ach.Length - 1) separator = "";
    		str += separator;
    	}
    	Output.Text(str);
	}
	
	internal static void WriteLine(int id, string sequence)
	{
		Sing s = new Sing(id);
		s.WriteLine(sequence);
	}
	
    
}
