/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.IO;

class SysInfo
{
	internal static bool Unix { get { return Path.DirectorySeparatorChar == '/'; } }
	
	internal static string DirFilePart = "dir";
	internal static string IniFilePart = "ini";
	
	internal static string IniFile(string name)
	{
		string str = Var.strPathDat + "/" + name + (Unix ? "lin" : "win") + ".txt";
		PathTreatment(str);
		return str;
	}
	
	internal static string PathTreatment(string str)
	{
		return Unix ? str : str.Replace('/', '\\');
	}
	
	internal static string XnView()
	{
		return Unix ? "xnview" : "C:\\Programme\\XnView\\xnview.exe";
	}
	
}
