/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections;

class Year
{
	internal static void Check(ref string name, ref int year)
	{
		if (name.Length < 8) return;
		string[] astr = name.Split(' ');
		if (name.Length < 2) return;
		if (Try(astr[astr.Length - 1], ref year)) name = name.Substring(0, name.Length - 7);
		else if (Try(astr[0], ref year)) name = name.Substring(7, name.Length - 7);
	}
	
	internal static string OutputAfterAlbum(int year)
	{
		return year <= 0 ? "" : " (" + year + ")";
	}
	
	static bool Try(string str, ref int year)
	{
		if (str.Length != 6) return false;
		if (str.Substring(0, 1) != "(" || str.Substring(5, 1) != ")") return false;
		try { year = Int32.Parse(str.Substring(1, 4)); return true; }
		catch { return false; }
	}
	
}

