/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using System;

class di
{
	// {<command>, <text>, <short>, <stock>}
	
	// database
	internal static string[] db =			{"db", "database", "", ""};
	internal static string[] dbAddDir =		{"a", "add directory", "", ""};
    internal static string[] dbCommand =	{"p", "prompt", "", ""};
	internal static string[] dbCreate =		{"cdb", "create database", "", ""};
	internal static string[] dbCreateF =	{"cdbff", "create database from file", "", ""};
	internal static string[] dbDrop =		{"d", "drop database", "", ""};
	internal static string[] dbRemoveDir =	{"r", "remove directory", "", ""};
	internal static string[] dbUpdateDir =	{"ud", "update directory", "", ""};
	internal static string[] dbUpdateF =	{"udff", "update directories from file", "", ""};
	
    // player
    internal static string[] enq =			{"e", "Enqueue", "enq", ""};
	internal static string[] play =			{"p", "Play", "play", Stock.MediaPlay};
    internal static string[] player =		{play[0], "player", "", ""};
    internal static string[] playnext =		{play[0] + "n", "next", ">|", Stock.MediaNext};
	internal static string[] playpause =	{"pause", "play/pause", "||", Stock.MediaPause};
	internal static string[] playprev =		{play[0] + "p", "previous", "|<", Stock.MediaPrevious};
	internal static string[] seekbwd =		{play[0] + "b", "seek backwards", "<<", Stock.MediaRewind};
	internal static string[] seekfwd =		{play[0] + "f", "seek forwards", ">>", Stock.MediaForward};
	internal static string[] voldown =		{"-", "volume down", "", Stock.Remove};
	internal static string[] volup =		{"+", "volume up", "", Stock.Add};
	
	// search
	internal static string[] limit = 		{"l", "limit", "", ""};
	internal static string[] order = 		{"o", "order", "", ""};
	internal static string[] sequence =		{"s", "sequence", "", ""};
	
	// general
	internal static string[] repeat =		{"<enter>", "repeat last command (for some)", "", ""};
	internal static string[] track =		{"#", "Track", "", ""};
	internal static string[] artist =		{"a", "artist", "", ""};
	internal static string[] album =		{"album", "Album", "", Stock.Cdrom};
	internal static string[] all =	    	{"all", "All", "all", ""};
	internal static string[] clear =		{"c", "clear", "", ""};
	internal static string[] cover =		{"c", "Cover", "", ""};
	internal static string[] details =		{"details", "details", "", ""};
	internal static string[] edit =			{"ed", "Edit", "", ""};
	internal static string[] exe =			{"exe", "executable", "", Stock.DialogAuthentication}; // Stop, DialogWarning // Stock.No
	internal static string[] ext =			{"e", "extension", "", ""};
	internal static string[] external =     {"external", "externally", "", ""};
    internal static string[] file     =     {"f", "file", "", ""};
    internal static string[] files     =    {"files", "files", "", ""};
    internal static string[] folder =		{"d", "folder", "", Stock.Directory};
	internal static string[] help =			{"h", "help", "", ""};
	internal static string[] go =			{"go", "Go", "", ""};
	internal static string[] gui =			{"g", "gui", "", ""};
	internal static string[] historyBwd =	{"hb", "history backwards", "", ""};
	internal static string[] historyFwd =	{"hf", "history forwards", "", ""};
	internal static string[] image =		{"i", "image", "", Stock.SelectColor};
	internal static string[] index =		{"i", "index", "", ""};
	internal static string[] prev =			{"l", "previous", "", ""};
	internal static string[] name =			{"n", "name", "", ""};
	internal static string[] newWindow =	{"newWindow", "newWindow", "", ""};
	internal static string[] next =			{"n", "next", "", ""};
	internal static string[] path =			{"p", "path", "", ""};
	internal static string[] quiz =			{"q", "Quiz", "", ""};
	// internal static string[] openExternal = {"oe", "Open externally", "", ""};
	
    internal static string[] open =         {"o", "open", "", ""};
    // internal static string[] openExtDir =   {"oed", "open folder externally", "", ""};
    internal static string[] openExtDir = Abgeleitet(open, folder, external, "", "");
    // internal static string[] openExtFile =  {"oef", "open file externally", "", ""};
    internal static string[] openExtFile = Abgeleitet(open, file, external, "", "");
    // internal static string[] openExtImg =   {"oei", "open image externally", "", ""};
    internal static string[] openExtImg = Abgeleitet(open, image, external, "", "");
    internal static string[] openDefApp =   {"oda", "open with defined application", "", "", "extra: defined application"}; // Achtung: 
    internal static string[] openStandApp = {"osta", "open with standard application", "", ""};
    internal static string[] quit =			{"q", "quit", "", ""};
	internal static string[] rnd =			{"r", "Random", "rnd", ""};
	internal static string[] rename =		{"ren", "rename", "ren", ""};
	internal static string[] search =		{"s", "search", "", ""};
	internal static string[] show =			{"show", "show", "show", ""};
	// internal static string[] showImage =	{"showImage", "show image", "", ""};
	internal static string[] showImage = Abgeleitet(show, image, "", "");
	// internal static string[] showTracks =	{"showTracks", "show files", "", ""};
	internal static string[] showTracks = Abgeleitet(show, files, "", "");
	internal static string[] test =		    {"test", "Test", "", ""};
	internal static string[] title =		{"t", "Title", "", ""};
	// internal static string[] visual =		{"v", "visualization", "", ""};
	internal static string[] xnview =		{"xnv", "xnview", "", ""};
	internal static string[] xrename =		{"x", "X-Rename", "", ""};
	internal static string[] year =			{"y", "year", "", ""};
	
	//
	// abgeleitete
	//
	
	internal static string[] enq_folder = Abgeleitet(enq, folder, "", "");//enq[1] + " " + folder[1];
	internal static string[] play_folder = Abgeleitet(play, folder, "", play[3]);
	internal static string[] rename_folder = Abgeleitet(rename, folder, "", "");
	internal static string[] xrename_folder = Abgeleitet(xrename, folder, "", "");
	
	static string[] Abgeleitet(string[] a1, string[] a2, string symbol, string stock)
	{
		return new string[]
		{
			a1[0] + a2[0],
			a1[1] + " " + a2[1],
			symbol,
			stock
		};
	}
	
	static string[] Abgeleitet(string[] a1, string[] a2, string[] a3, string symbol, string stock)
	{
		return new string[]
		{
			a1[0] + a2[0] + a3[0],
			a1[1] + " " + a2[1] + " " + a3[1],
			symbol,
			stock
		};
	}
}

