/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using System;
using System.IO;

class ButtonPlus : Button
{
	internal static EventHandler ehButtonUsed = new EventHandler(Button_Used);
    Menu menu = null;
	
	internal ButtonPlus(bool cover, Ext.Typen typ, string name, string path)
    {
    	HBox box = new HBox();
		cover = false; // deactivated, takes too much time for 30
		if (cover)
		{
			string file = path + System.IO.Path.DirectorySeparatorChar + Img.folder; //"/folder.jpg";
			if (!File.Exists(file)) cover = false;
		    else
		    {
		    	box.PackStart(new Image(Img.Mini(false, file)), false, false, 0);
			}
		}
		else
		{
			box.PackStart(Ext.Typ2StockImage(typ), false, false, 0);
		}
		
		//Label space = new Label(" ");
		//box.PackStart(label, false, false, 0);
		
		Label label = new Label(name);
		label.Justify = Justification.Left;
		//label.WidthRequest = cx - (cover ? Img.mini : 20);
		//label.WidthRequest = 9999;
		label.Xalign = 0;
		//box.Add(label);
		box.PackStart(label, false, true, Mvar.padding); 
		/*
		CheckButton cb = new CheckButton(name);
		cb.WidthRequest = cx;
		box.Add(cb);
		*/
		//this.Child = box;
		//this.PackStart(box, true, true, 0);
		this.Add(box);
		this.Clicked += ehButtonUsed;
		this.Name = path;
		
		if (typ == Ext.Typen.folder)// album)
		{
			//Console.WriteLine("path:" + path);
			menu = Menus.Folder(path, Img.Cover(path)); // isFile ? path :
		}
		else //if (typ == Ext.Typen.audio)
		{
			menu = Menus.File(typ, path);
		}
		if (menu != null) menu.ShowAll();
		
    }
	
	internal static void Button_Used(object obj, EventArgs args)
	{
		Button o = (Button)obj;
		if (o.Name != View.imgNoResult1 && o.Name != View.imgNoResult2) ProcessStart.Execute(o.Name);
	}
	
	protected override bool OnButtonPressEvent(Gdk.EventButton eb)
	{
		if (eb.Button == 3 && menu != null)
		{
		    menu.Popup();
			return true;
		}
		return base.OnButtonPressEvent(eb);
	}
   	
    
}

