/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using System;

class Buttons
{
    static Button Get(string name, Button o, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	if (clicked != null) o.Clicked += clicked;
    	if (pressed != null) o.Pressed += pressed;
    	if (released != null) o.Released += released;
    	o.Name = name;
    	return o;
    }
    
    static Button GetByImage(string name, Gtk.Image image, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	Button o = new Button(image);
    	return Get(name, o, clicked, pressed, released);
    }
    
    static Button GetByPixbuf(string name, Pixbuf pixbuf, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	return GetByImage(name, new Gtk.Image(pixbuf), clicked, pressed, released);
    }
    
    internal static Button GetByResource(string name, string resource, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	Pixbuf pixbuf = Resource.GetPixbuf(resource);
    	return GetByPixbuf(name, pixbuf, clicked, pressed, released);
    }
	
    internal static Button GetBy_di(string[] di, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	Gtk.Image image = new Gtk.Image();
    	image.Stock = di[3];
		new Tooltips().SetTip(image, di[1], null);
    	return GetByImage(di[0], image, clicked, pressed, released);
    }
    
    internal static Button GetByStock(string name, string stock, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	Gtk.Image image = new Gtk.Image();
    	image.Stock = stock;
    	return GetByImage(name, image, clicked, pressed, released);
    }
    
	internal static Button GetByText(string name, string text, EventHandler clicked, EventHandler pressed, EventHandler released)
    {
    	Button o = new Button(text);
    	return Get(name, o, clicked, pressed, released);
    }
    
    internal static Button LevelUp()
    {
    	return new Button(Resource.Typ2Image("level-up"));
    }
	
    internal static Button Options()
    {
    	return new Button(Resource.Typ2Image("options"));
    }
	
    
}

