/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBibGtk;
using System;

class DialogPass : Dialog
{
	internal static bool Start(Fenster f)
	{
		DialogPass d = new DialogPass(f);
   		bool cancel = d.cancel;
   		bool ok = d.ok;
   		d.Destroy();
   		if (cancel) return false;
   		if (!ok) 
   		{
   			f.Message(MessageType.Warning, "password not accepted");
   			return false;
   		}
   		return true;
	}
	
	internal bool cancel = false;
	internal bool ok = false;
	Entry entry = new Entry();
	
    internal DialogPass(Window win) : base("password", win, Gtk.DialogFlags.DestroyWithParent)
    {
    	entry.HeightRequest = 1;
    	entry.WidthRequest = 1;
    	this.HasSeparator = false;
    	this.Modal = true;
    	this.VBox.Add(entry);
        entry.Show();
        this.AddButton(DialogForm.LabelText(ResponseType.Ok), ResponseType.Ok);
        this.AddButton(DialogForm.LabelText(ResponseType.Cancel), ResponseType.Cancel);
        this.Response += new ResponseHandler(This_Response);
        this.Run();
    }
    
    void This_Response(object o, ResponseArgs args)
    {
    	if (args.ResponseId == ResponseType.Cancel) cancel = true;
    	else if (entry.Text == "password") ok = true;
    }

}
