/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBib;
using MiBibGtk;
using System;
using System.Collections;
using System.Diagnostics;

class EditForm : Fenster
{
	internal static void Start(string file)
	{
		Application.Init();
    	new EditForm(file);
    	Application.Run();
	}
	
	internal static string title = "Edi-Toooor";
	
	ArrayList orig;
	string file;
	
	EditForm(string file) : base(title, Var.icon)
	{
		this.file = file;
		this.Move(1, 1);
		this.SetDefaultSize(Ini.GetInt("DefaultWidth"), Ini.GetInt("DefaultHeight"));
		//this.SetPosition(WindowPosition.Center);
		Init();
		orig = InOut.File2ArrayList(file, false, false);
		for (int i = 0; i < orig.Count - 1; i++)
		{
			buffer.Text += orig[i] + "\n";
		}
		if (orig.Count > 0) buffer.Text += orig[orig.Count - 1];
		this.ShowAll();
	}
	TextBuffer buffer;
	TextView view;
	VBox cnt = new VBox();
	
	void Init()
	{
		this.Add(cnt);
		
		MenuBar mb = new MenuBar();
		cnt.PackStart(mb, false, false, 0);
		
		AccelGroup agrp = new AccelGroup();
		AddAccelGroup(agrp);
		Menu m;
		MenuItem mi;
		
		m = new Menu();
		mi = new MenuItem("_Datei");
		mi.Submenu = m;
		mb.Append(mi);
		
		mi = new ImageMenuItem(Stock.Save, agrp);
		// mi.AddAccelerator("activate", agrp, new AccelKey(Gdk.Key.F11, Gdk.ModifierType.None, AccelFlags.Visible));
		mi.Activated += new EventHandler(OnMenuSave); // todo 04.07.2008 sharpdevelop
		m.Append(mi);
		
		ScrolledWindow sw = new ScrolledWindow();
		cnt.Add(sw);
		CreateTextView();
		sw.Add(view);
		
		
	}
	
	void OnMenuSave(object o, EventArgs args)
	{
		// Console.WriteLine(file + "~");
		InOut.ArrayList2File(orig, file + ".backup");
		
		string[] astr = buffer.Text.Split('\n');
		ArrayList save = new ArrayList();
		foreach (string str in astr) save.Add(str);
		InOut.ArrayList2File(save, file);
		Console.WriteLine(file);
	}
	
	void CreateTextView()
	{
		view = new TextView ();
		view.WrapMode = WrapMode.Word;
		//view.KeyPressEvent += new KeyPressEventHandler (OnKeyPress);
		//view.MotionNotifyEvent += new MotionNotifyEventHandler (OnMotionNotify);
		//view.VisibilityNotifyEvent += new VisibilityNotifyEventHandler (OnVisibilityNotify);
		//view.ButtonReleaseEvent += new ButtonReleaseEventHandler (OnButtonRelease);

		//ShowPage (view.Buffer, 1);
		buffer = view.Buffer;
	}
	
			
}
