/* Copyright (C) 2002-NOW Mischa Lrken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using MiBib;
using System;
using System.Collections;
using System.IO;

class FolderImages : VBox
{
	static AttachOptions ao = AttachOptions.Fill;
	int max;
	Menu menu = new Menu();
	ScrolledWindow sw;
	string lastPath = "";
	Table tbl;
	VBox cnt = new VBox();
	
	string[] imageOrder = new string[]
    {
    	Ini.GetString("CoverName"), //"folder.jpg",
    	"back.jpg",
    	"cd.jpg",
		"tracks.jpg"
    };
    
    internal FolderImages() : base()
    {
	    Init();
	    CreateContainer();
	    CreateTable(1);
    }
	/*
    void Button_Clicked(object obj, EventArgs args)
    {
    	Button o = (Button)obj;
    	if (o.Name == di.enq[0]) Player.PlayFolder(true, lastPath);
    	else if (o.Name == di.play[0]) Player.PlayFolder(false, lastPath);
    	else if (o.Name == di.xrename[0]) XrenameWindow.Start(lastPath);
    	// else if (o.Name == "tracks") Gui.gui.view.UpdateFromDirectory(lastPath);
    }
    */
    void CreateContainer()
    {
    	//Console.WriteLine("FolderImages.CreateContainer");
    	if (sw != null)
    	{
    		max = MaxX();
    		try { foreach (ImageButton o in tbl) o.Dispose(); } catch { }
    		cnt.Remove(sw);
    		sw.Dispose();
    		sw = null;
    	}
    	sw = new ScrolledWindow();
    	// sw.HscrollbarPolicy = PolicyType.Never;
    	sw.SizeAllocated += new SizeAllocatedHandler(sw_SizeAllocated); // todo 04.07.2008 sharpdevelop
    	cnt.PackStart(sw, true, true, 0);
    }
    int lastMaxX = -1;
	int lastMaxY = -1;
	int number;
	int MaxX() { return (int)sw.Hadjustment.PageSize; }
	int MaxY() { return (int)sw.Vadjustment.PageSize; }
	
	void sw_SizeAllocated(object o, SizeAllocatedArgs args)//EventArgs args) // todo 04.07.2008 sharpdevelop
    {
    	try { Gui.gui.pc.TestLabel(2, sw.VScrollbar.Visible.ToString()); } catch {}
    	
    	int x = MaxX(); //Console.WriteLine("MaxX=" + x);
    	int y = MaxY(); //Console.WriteLine("MaxY=" + y);
    	if (x < 1 || y < 1) return;
    	int yNeeds = number * x;
    	if (yNeeds >= y && !sw.VScrollbar.Visible)// && yNeeds <= y + GuiVar.approxScrollbar)
    	{
    		//Console.WriteLine("FolderImages.sw_SizeAllocated: critical");
    		int xt = x - GuiVar.approxScrollbar;
    		int yt = number > 0 ? (int)(y / number) : 0;
    		x = xt > yt ? xt : yt;
    		// x -= GuiVar.approxScrollbar;
    		if (x < 1) x = 1;
    	}
    	Gui.gui.pc.TestLabel(0, x.ToString());
    	Gui.gui.pc.TestLabel(1, y.ToString());
    	if (x == lastMaxX && y == lastMaxY) return;
    	lastMaxX = x;
    	lastMaxY = y;
    	//Console.WriteLine("FolderImages.sw_SizeAllocated: " + x + " x " + y);
    	foreach (ImageButton ib in tbl) ib.Update(x, x);
    }
    internal void sw_SizeAllocated_update()
    {
    	foreach (ImageButton ib in tbl) ib.Update(lastMaxX, lastMaxX);
    }
    
    void CreateTable(uint rows)
    {
    	number = (int)rows;
    	tbl = new Table(rows, 1, false);
    	sw.AddWithViewport(tbl);
    }
    
    void Init()
    {
    	this.Add(cnt);
    	
    	//Button button;
    	//EventHandler ehButton_Clicked = new EventHandler(Button_Clicked);
    	//HBox hbox;
    	//VBox controls = new VBox();
    	
    	//hbox = new HBox();
    	/*
    	button = new Button("tracks");
    	button.Clicked += ehButton_Clicked;
    	button.Name = "tracks";
    	hbox.PackStart(button);
    	*/
    	//controls.PackStart(hbox);
    	
    	//hbox = new HBox();
    	/*
    	button = new Button(di.play[1]);
    	button.Clicked += ehButton_Clicked;
    	button.Name = di.play[0];
    	hbox.PackStart(button);
    	
    	button = new Button(di.enq[1]);
    	button.Clicked += ehButton_Clicked;
    	button.Name = di.enq[0];
    	hbox.PackStart(button);
    	
    	button = new Button(di.xrename[1]);
    	button.Clicked += ehButton_Clicked;
    	button.Name = di.xrename[0];
    	hbox.PackStart(button);
    	
    	controls.PackStart(hbox);
    	
    	cnt.PackEnd(controls, false, false, 0);
    	*/
    }
    
    protected override bool OnButtonPressEvent(Gdk.EventButton eb)
	{
		if (eb.Button == 3)
		{
		    menu.Popup();
			return true;
		}
		return base.OnButtonPressEvent(eb);
	}
   	
    ArrayList Sort(string path, string[] files)
    {
		ArrayList alOld = new ArrayList();
		foreach (string file in files)
		{
			if (Ext.Path2Typ(file) == Ext.Typen.image) alOld.Add(file);
		}
		ArrayList alNew = new ArrayList();
		foreach (string file in imageOrder) SortCheck(ref path, file, ref alOld, ref alNew);
		foreach (string file in alOld) alNew.Add(file);
		return alNew;
    }
    
    void SortCheck(ref string path, string file, ref ArrayList alOld, ref ArrayList alNew)
    {
    	string fullPath = path + "/" + file;
    	if (!alOld.Contains(fullPath)) return;
    	alNew.Add(fullPath);
    	alOld.Remove(fullPath);
    }
    
    internal void Update(string path)
    {
    	if (path == lastPath) return;
    	UpdatePigs(path);
    	this.ShowAll();
    	lastPath = path;
    	menu = Menus.Folder(path, Img.Cover(path));
    	menu.ShowAll();
    	//Console.WriteLine("FolderImages.Update exit");
    	
    }
    
    void UpdatePigs(string path)
    {
    	//Console.WriteLine("FolderImages.UpdatePigs");
    	CreateContainer();
		string[] astr;
		
		// todo
    	try { astr = Directory.GetFiles(path); } catch { return; }
    	// weil path / benutzt, aber Directory.GetFiles mit \ in Windows anhngt sieht es im Tooltip doof aus
    	
    	ArrayList files = Sort(path, astr);
    	ArrayList al = new ArrayList();
    	int count = 0;
    	int limit = Gui.gui.sc.Limit;
    	foreach (string file in files)
    	{
    		ImageButton ib = new ImageButton(false, true, count++ < limit, max, max, file);
			al.Add(ib);
    	}
    	CreateTable((uint)al.Count);// + 1);
    	uint xPadding = 0;
    	uint yPadding = 0;
    	for (int i = 0; i < al.Count; i++)
    	{
    		tbl.Attach((ImageButton)al[i], 0, 1, (uint)i, (uint)i+1, ao, ao, xPadding, yPadding);
    	}
    }
    
}

