/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using System;

class ImageButton : Button
{
	bool isFile;
	bool cover;
	bool showCover;
	int xmax;
	int ymax;
	Menu menu;
	string folder;
	string name;
	string path;
	Pixbuf orig = null;
	
	internal ImageButton(bool cover, bool isFile, bool showCover, int xmax, int ymax, string path) : base()
    {
    	this.cover = cover;
    	this.isFile = isFile;
    	this.showCover = showCover;
    	this.xmax = xmax;
    	this.ymax = ymax;
    	this.path = path;
    	folder = isFile ? System.IO.Path.GetDirectoryName(path) : path;
    	A();
    	if (xmax*ymax > 0) Update(xmax, ymax);
    }
	
    void A()
    {
    	if (showCover) orig = Img.Original(path, cover, false);
    	if (orig == null) InitText();
    	/*
    	string image = 
    	Console.WriteLine("path=" + path);
		Console.WriteLine("Img.Cover(path)=" + Img.Cover(path));
		*/
		menu = Menus.Folder(folder, isFile ? path : Img.Cover(path));
    	menu.ShowAll();
    	this.Clicked += ButtonPlus.ehButtonUsed;
    	this.Name = path;
    	this.Relief = ReliefStyle.None;
    	//Console.WriteLine("path=" + path);
    	new Tooltips().SetTip(this, Peculiar.Substitute(path), null);
    }
    
	protected override bool OnButtonPressEvent(Gdk.EventButton eb)
	{
		if (eb.Button == 3)
		{
		    menu.Popup();
			return true;
		}
		return base.OnButtonPressEvent(eb);
	}
   	
    void InitText()
    {
    	name = Peculiar.Substitute(System.IO.Path.GetFileName(path));
    	bool cont = true;
    	while (cont)
    	{
    		if (name.Length > 0 && name.Substring(0, 1) == "/")
    		{
    			name = name.Substring(1, name.Length - 1);
    		}
    		else cont = false;
    	}
    	name = name.Replace("/", "\n");    	
    	this.Label = name;
    }
    
    internal void Update(int xmax, int ymax)
    {
    	this.xmax = xmax;
    	this.ymax = ymax;
    	if (xmax > 0) this.WidthRequest = xmax; 
    	if (ymax > 0) this.HeightRequest = ymax;
    	if (orig != null) UpdateCover();
    }
    
    void UpdateCover()
    {
    	// todo: hier läuft der Speicher hoch und es hängt bei Bewegung oder vielen Covern oder den FolderImages
    	this.Image = new Gtk.Image(Thumbs.Get(cover, xmax-GuiVar.approxDiffButtonImage, ymax-GuiVar.approxDiffButtonImage, orig));
    }
     
}

