/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using MiBib;
using System;
using System.Diagnostics;
using System.Threading;

class PlayerControl : VBox
{
	internal void TestLabel(int i, string str)
	{
		try { testLabel[i].Text = str; } catch { }
	}
	void Test0(object o, EventArgs ea)
	{
		string c = "xmms2-launcher";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
		//StockForm.Start();
		//Gui.gui.gw.view.Test();
	}
	
	//int test = -1;
	void Test1(object o, EventArgs ea)
	{
		string c = "xmms2 list";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
		
		//Gdk.CursorType.GetValues(CursorType);
		//Gui.gui.fi.sw_SizeAllocated_update();
		//test++;
		
		
		//Gui.gui.GdkWindow.Cursor = new Gdk.Cursor(Gdk.CursorType.(test));//.Watch); 
	}
	
	void Test2(object o, EventArgs ea)
	{
		string c = "xmms2 add \"/home/mischa/test 2.mp3\"";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
	}
	
	void Test3(object o, EventArgs ea)
	{
		string c = "xmms2 play";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
	}
	
	void Test4(object o, EventArgs ea)
	{
		string c = "xmms2 stop";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
	}
	
	void Test5(object o, EventArgs ea)
	{
		string c = "xmms2 quit";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
	}
	
	void Test6(object o, EventArgs ea)
	{
		string c = "xmms2 clear";
		Console.WriteLine(c);
		try { Process.Start(c); }
		catch (Exception e) { Console.WriteLine(e.Message); }
	}
	
	internal PlayerControl() : base()
    {
        Init();
    }
	
	EventHandler ehButtonUsed;
    EventHandler ehButtonReleased;
    int sleep = 250;
    string cmdRepeat;
    Timer timerRepeat;
    
    void Button_Used(object o, EventArgs args)
	{
		Button btn = (Button)o;
		// Console.WriteLine(btn.Name);
		if (btn.Name == "home") Home();
		else if (btn.Name == "level-up") Gui.gui.view.UpdateFromDirectoryLevelUp();
		else if (btn.Name == di.historyBwd[0]) Gui.gui.HistoryBack();
		else if (btn.Name == di.historyFwd[0]) Gui.gui.HistoryBack();
		else Input.Exec(btn.Name);
		
		if (   btn.Name == di.seekbwd[0] || btn.Name == di.seekfwd[0]
			|| btn.Name == di.voldown[0] || btn.Name == di.volup[0])
		{
			cmdRepeat = btn.Name;
			timerRepeat = new Timer(new TimerCallback(Pressed), null, sleep, sleep);
		}
	}
	
    void Button_Released(object o, EventArgs args)
	{
    	if (timerRepeat != null) { timerRepeat.Dispose(); timerRepeat = null; }
	}
	
	internal void Home()
	{
		Gui.gui.view.Home();
	}
	
    void Init()
    {
    	ehButtonUsed = new EventHandler(Button_Used);
    	ehButtonReleased = new EventHandler(Button_Released);
    	Button b;
    	HBox bx;
    	
    	//b = Buttons.Options();
    	//b.Clicked += new EventHandler(Options_Clicked);
    	//this.Add(b);
    	
    	VBox cnt = new VBox(false, 0);
    	this.PackStart(cnt, false, false, 0);
    	
    	bx = new HBox(false, 0);
    	cnt.Add(bx);
    	/*
    	b = Buttons.LevelUp();
    	b.Clicked += ehButtonUsed;
    	b.Name = "level-up";
    	bx.Add(b);
    	*/
    	bx.Add(Buttons.GetByStock("level-up", //"resnext.png",  
				//new Pixbuf(MainClass.datpath + "/img/gohome.png"),
				Stock.GoUp,
				//new EventHandler(Home_Clicked), null, null);
				ehButtonUsed, null, null));
    	
    	bx.Add(Buttons.GetByStock("home", //"resnext.png",  
				//new Pixbuf(MainClass.datpath + "/img/gohome.png"),
				Stock.Home,
				//new EventHandler(Home_Clicked), null, null);
				ehButtonUsed, null, null));
    	
    	if (Ini.GetBool("UseBetaFeatures"))
    	{
	    	bx = new HBox(false, 0);
	    	cnt.Add(bx);
	    	b = Buttons.GetByStock(di.historyBwd[0], //"resprev.png", 
	    					Stock.GoBack, // "resprev.png",
	    					null, ehButtonUsed, ehButtonReleased);
	    	bx.Add(b);
	    	b = Buttons.GetByStock(di.historyFwd[0], //"resnext.png",  
	    					//"resnext.png",
	    					Stock.GoForward,
	    					null, ehButtonUsed, ehButtonReleased);
	    	bx.Add(b);
    	}
    	
    	bx = new HBox(false, 0);
    	cnt.Add(bx);
    	//b = Buttons.GetByText(di.voldown[0], "<V", null, ehButtonUsed, ehButtonReleased);
    	//bx.Add(b);
    	bx.Add(Buttons.GetBy_di(di.voldown, null, ehButtonUsed, ehButtonReleased));
    	//b = Buttons.GetByText(di.volup[0], "V>", null, ehButtonUsed, ehButtonReleased);
    	//bx.Add(b);
    	bx.Add(Buttons.GetBy_di(di.volup, null, ehButtonUsed, ehButtonReleased));
    	
    	bx = new HBox(false, 0);
    	cnt.Add(bx);
    	bx.Add(Buttons.GetBy_di(di.playprev, null, ehButtonUsed, ehButtonReleased));
    	b = Buttons.GetBy_di(di.playnext, null, ehButtonUsed, ehButtonReleased);
		bx.Add(b);
    	
    	bx = new HBox(false, 0);
    	cnt.Add(bx);
    	bx.Add(Buttons.GetBy_di(di.seekbwd, null, ehButtonUsed, ehButtonReleased));
    	b = Buttons.GetBy_di(di.seekfwd, null, ehButtonUsed, ehButtonReleased);
		bx.Add(b);
    	
    	bx = new HBox(false, 0);
    	cnt.Add(bx);
    	bx.Add(Buttons.GetBy_di(di.playpause, ehButtonUsed, null, null));
    	bx.Add(Buttons.GetBy_di(di.play, ehButtonUsed, null, null));
    	
		if (Ini.GetBool("UseBetaFeatures"))
		{
	    	b = new Button("Test 0");
	    	b.Clicked += new EventHandler(Test0);
	    	cnt.Add(b);
	    	
	    	b = new Button("Test 1");
	    	b.Clicked += new EventHandler(Test1);
	    	cnt.Add(b);
	    	
	    	b = new Button("Test 2");
	    	b.Clicked += new EventHandler(Test2);
	    	cnt.Add(b);
	    	
	    	b = new Button("Test 3");
	    	b.Clicked += new EventHandler(Test3);
	    	cnt.Add(b);
	    	
	    	b = new Button("Test 4");
	    	b.Clicked += new EventHandler(Test4);
	    	cnt.Add(b);
	    	
	    	b = new Button("Test 5");
	    	b.Clicked += new EventHandler(Test5);
	    	cnt.Add(b);
	    	
	    	b = new Button("Test 6");
	    	b.Clicked += new EventHandler(Test6);
	    	cnt.Add(b);
	    	
	    	SystemTrayStatusIcon_Init();
	    	Button l = new Button("Test X");
	    	cnt.Add(l);
	    	l.ButtonPressEvent += new ButtonPressEventHandler(OnLabelButtonPressEvent);
	    	
			
			testLabel = new Label[testLabels];
			for (int i = 0; i < testLabels; i++) 
			{
				testLabel[i] = new Label("Test " + i);
				cnt.Add(testLabel[i]);
			}
		}
    }
    int testLabels = 4;
	internal Label[] testLabel;
    
    private void OnLabelButtonPressEvent(object o, ButtonPressEventArgs args)
    {
    	if(args.Event.Button == 3 && systemTrayStatusIconMenu != null) {
            systemTrayStatusIconMenu.Popup();
            args.RetVal = false;
        }
    }
        
        
	Menu systemTrayStatusIconMenu;
	void SystemTrayStatusIcon_Init()
	{
		systemTrayStatusIconMenu = new Menu();
		ImageMenuItem mi = new ImageMenuItem("Quit");
		mi.Activated += new EventHandler(SystemTrayStatusIconMenu_Activated);
		mi.Image = new Gtk.Image(Stock.Quit, IconSize.Menu);
		systemTrayStatusIconMenu.Add(mi);
		systemTrayStatusIconMenu.ShowAll();
    }
    void SystemTrayStatusIconMenu_Activated(object o, EventArgs args)
	{
		Application.Quit();
	}
    /*
    void Options_Clicked(object o, EventArgs args)
    {
    	OptionsForm.Start();
    }
    */
    void Pressed(object state) 
	{
    	Console.Write(".");
		Input.Exec(cmdRepeat);
	}
	
		
}

