/* Copyright (C) 2002-NOW Mischa Lrken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gdk;
using Gtk;
using MiBibGtk;
using System;
using System.Collections;
using System.Diagnostics;
using System.Threading;

class QuizForm : Fenster
{
	internal static void Start(ArrayList al)
	{
		Application.Init();
    	new QuizForm(al);
    	Application.Run();
	}
	
	ArrayList al;
	Entry[] entry;
	EventHandler ehButton_Clicked;
	int buttonWidth = 50;
	ScrolledWindow scrolledWindow;
	
	internal static string title = di.rnd[1];
	ToggleButton buttonShow;
	VBox cnt = new VBox();
	VBox cnt2 = new VBox();
	
	internal QuizForm(ArrayList al) : base(title, Var.icon)
	{
		this.al = al;
		int left, top, width, height;
		Gui.Rect(out left, out top, out width, out height);
		this.KeepBelow = true;
		Init();
		this.Move(left, top);
		// this.Resize(View.total, height);
		//this.Resize(Gui.gui.view.Allocation.Width, height); // Parsing error
		this.Resize(Gui.gui.view.sw.Allocation.Width - 2 * (int)(Gui.FrameWidth()), height);
		this.ShowAll();
		this.KeepAbove = true;
	}
	
	/*
	internal QuizForm(ArrayList al) : base(title)
	{
		this.al = al;
		int left, top, width, height;
		//Gui.Rect(out left, out top, out width, out height);
		Rectangle rect = Gui.gui.view.Allocation;
		this.KeepBelow = true;
		Init();
		this.Move(rect.Left, rect.Top);
		// this.Resize(View.total, height);
		//this.Resize(Gui.gui.view.Allocation.Width, height); // Parsing error
		this.Resize(rect.Width, rect.Height);
		this.ShowAll();
		this.KeepAbove = true;
	}
	*/
	void AddButton(ref HBox container, int i, string text, bool fill)
	{
		Button button = new Button(text);
		if (fill) container.Add(button);
		else container.PackStart(button, false, false, 0);
		button.Clicked += ehButton_Clicked;
		button.Name = i.ToString();
		button.WidthRequest = buttonWidth;
	}
	
	void AddControls(int i)
	{
		HBox hbox = new HBox(false, 0);
		cnt2.PackStart(hbox, false, false, 0);
		AddButton(ref hbox, i, (i+1).ToString(), false);
		AddButton(ref hbox, i, di.play[2], false);
		AddButton(ref hbox, i, di.enq[2], false);
		AddButton(ref hbox, i, di.show[2], false);
		entry[i] = GetEntry();
		hbox.Add(entry[i]);
	}
	
	new void Action(int nr, string text)
	{
		string path = (string)al[nr];
		if (text == di.enq[2]) Player.PlayFile(true, path);
		else if (text == di.play[2]) Player.PlayFile(false, path);
		else if (text == di.show[2])
		{
			entry[nr].Text = (entry[nr].Text == "" ? path : "");
		}
		else // Ziffern-Button gedrckt
		{
			Player.CreatePlaylistFromArrayListPath(al, false, nr, al.Count);
		}
	}
	
	void Button_Clicked(object obj, EventArgs args)
	{
		Button button = (Button)obj;
		int nr = Int32.Parse(button.Name);
		if (nr == -1) 
		{
			if (button.Label == di.all[2]) Player.CreatePlaylistFromArrayListPath(al, false, 0, al.Count);
			else if (button.Label == di.enq[2])
			{
				for (int i = 0; i < al.Count; i++) Action(i, di.enq[2]);
			}
			else if (button.Label == di.play[2]) Player.CreatePlaylistFromArrayListPath(al, false, 0, al.Count);
		}
		else 
		{
			Action(nr, button.Label);
		}
	}
	
	void Show_Clicked(object obj, EventArgs args)
	{
		for (int i = 0; i < al.Count; i++)
		{
			entry[i].Text = (buttonShow.Active ? (string)al[i] : "");
		}
	}
	
	Entry GetEntry()
	{
		Entry entry = new Entry();
		return entry;
	}
	
	void Init()
	{
		entry = new Entry[al.Count];
		ehButton_Clicked = new EventHandler(Button_Clicked);
		this.Add(cnt);
		
		HBox hbox = new HBox(false, 0);
		cnt.PackStart(hbox, false, false, 0);
		AddButton(ref hbox, -1, di.all[2], true);
		AddButton(ref hbox, -1, di.play[2], true);
		AddButton(ref hbox, -1, di.enq[2], true);
		
		buttonShow = new ToggleButton(di.show[2]);
		buttonShow.Clicked += new EventHandler(Show_Clicked);
		buttonShow.WidthRequest = buttonWidth;
		hbox.Add(buttonShow);
		
		scrolledWindow = new ScrolledWindow();
    	cnt.PackStart(scrolledWindow, true, true, 0);
    	scrolledWindow.AddWithViewport(cnt2);
		
    	for (int i = 0; i < al.Count; i++) AddControls(i);
	}
	
	
}

