/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBibGtk;
using System;
using System.Collections;
using System.IO;

class ReportsForm : Fenster
{
	internal static string title = "Reports";
	
	internal static void Start()
	{
		Application.Init();
    	new ReportsForm();
    	Application.Run();
	}
	
	VBox cnt = new VBox();
	
	ReportsForm() : base(title, Var.icon)
	{
		Init();
		this.SetDefaultSize(600, 480);
		this.ShowAll();
	}
	
	void Button_Clicked(object obj, EventArgs args)
	{
		Button button = (Button)obj;
		ListStore store;
		string[] cols;
		string[] headers;
		string[] types;
		string query;
		if (button.Name == q01)
		{
			cols = new string[] {"name", "albums", "sings", "rnd", "path"};
			headers = new string[] {"name", "albums", "sings", "rnd", "path"};
			query = "FROM dir";
			types = new string[] {"string", "int", "int", "int", "string"};
			store = new ListStore(typeof(string), typeof(int), typeof(int), typeof(int), typeof(string));
		}
		else if (button.Name == q02)
		{
			cols = new string[] {"COUNT(id)"};
			headers = new string[] {"sings"};
			query = "FROM sing";
			types = new string[] {"int"};
			store = new ListStore(typeof(int));
		}
		else if (button.Name == q03)
		{
			cols = new string[] {"COUNT(dir_id)"};
			headers = new string[] {"COUNT(dir_id)"};
			query = "FROM random_sing";
			types = new string[] {"int"};
			store = new ListStore(typeof(int));
		}
		else if (button.Name == q04)
		{
			cols = new string[] {"COUNT(id)"};
			headers = new string[] {"COUNT(id)"};
			query = "FROM album";
			types = new string[] {"int"};
			store = new ListStore(typeof(int));
		}
		else if (button.Name == q05)
		{
			cols = new string[] {"COUNT(dir_id)"};
			headers = new string[] {"COUNT(dir_id)"};
			query = "FROM random_album";
			types = new string[] {"int"};
			store = new ListStore(typeof(int));
		}
		else return;
		MySqlQueryForm.Start(store, cols, headers, types, query);
	}
	
	string q01 = "Verzeichnisse";
	string q02 = "Sings";
	string q03 = "Sings RND";
	string q04 = "Albums";
	string q05 = "Albums RND";
	
	void Init()
	{
		Button button;
		
		this.Add(cnt);
		
		VBox bx = new VBox();
		cnt.Add(bx);
		
		button = new Button(q01);
		button.Clicked += new EventHandler(Button_Clicked);
		button.Name = q01;
		bx.Add(button);
		
		button = new Button(q02);
		button.Clicked += new EventHandler(Button_Clicked);
		button.Name = q02;
		bx.Add(button);
		
		button = new Button(q03);
		button.Clicked += new EventHandler(Button_Clicked);
		button.Name = q03;
		bx.Add(button);
		
		button = new Button(q04);
		button.Clicked += new EventHandler(Button_Clicked);
		button.Name = q04;
		bx.Add(button);
		
		button = new Button(q05);
		button.Clicked += new EventHandler(Button_Clicked);
		button.Name = q05;
		bx.Add(button);
		
		Entry entry;
		entry = new Entry();
		entry.Text = "SELECT type, COUNT(type) FROM sing GROUP BY type;";
		bx.Add(entry);
		entry = new Entry();
		entry.Text = "SELECT rnd, COUNT(rnd) FROM sing GROUP BY rnd;";
		bx.Add(entry);
		entry = new Entry();
		entry.Text = "SELECT rnd, COUNT(rnd) FROM album GROUP BY rnd;";
		bx.Add(entry);
		
	}
	
}
