/* Copyright (C) 2002-NOW Mischa Lörken

This file is part of FindYourMedia (FYM), more info under <http://www.FindYourMedia.org>.

FYM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FYM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FYM. If not, see <http://www.gnu.org/licenses/>.
*/

using Gtk;
using MiBib;
using System;
using System.IO;
using System.Collections;

class View : VBox
{

Menu menu = new Menu();
	
    protected override bool OnButtonPressEvent(Gdk.EventButton eb)
	{
		if (eb.Button == 3)
		{
		    menu.Popup();
			return true;
		}
		return base.OnButtonPressEvent(eb);
	}
   	
   	
   	
	int lastXmax = 0;
	int lastYmax = 0;
	int xmax;
	int ymax;
	
	uint cols;
	uint rows;
	
    static bool lastNoResults = true;
    internal static string imgNoResult1 = "img/Nope, nothing...";
    internal static string imgNoResult2 = "img/No, nuttin'...";
    
	internal ScrolledWindow sw;
	string lastPath = "";
	Table table1 = new Table(0, 0, false);
	Table table2 = new Table(0, 0, false);
	internal static VBox cnt = new VBox();  // kann raus
	VBox vbox = new VBox();
	
	// this
	// - HBox address ( entry , button ) // kann raus
	// - VBox cnt // kann raus
    //   |_ sw    
    //      |_ vbox
    //         |_table1 (graphical) and/or table2 (textual)
    
	internal View() : base()
    {
		Init();
    }
	
	// internal static Breite
    internal void Test()
    {
    	int i = 0;
    	foreach (Widget w in vbox) 
    	{
    		string str = ++i + ": " + w.Name;
    		//Console.WriteLine(str);
    		Gui.gui.Message(str);
		}
    }
    
	void ArrayList2Cover(ArrayList al)
    {
    	if (rows * cols == 0) return;
    	CreateGraphicalTable();
    	
    	uint col = 0;
    	int items = (int)(rows * cols);
    	if (items > al.Count) items = al.Count;
    	uint row = 0;
    	for (int i = 0; i < items; i++)
    	{
    		ImageButton ib = new ImageButton(true, false, true, xmax, ymax, (string)al[i]);
    		table1.Attach(ib, col, col+1, row, row+1, AttachOptions.Expand, AttachOptions.Expand, 0, 0);
    		col++;
    		if (col == cols)
    		{
    			col = 0;
    			row++;
    		}
    		
    	}
    }
    
    void CreateContainer(string path)
    {
    	//Console.WriteLine("View.CreateContainer");
    	Gui.gui.entry.Text = path;
    	if (sw != null)
    	{
    		cnt.Remove(sw);
    		sw.Dispose();
    		sw = null;
    	}
    	sw = new ScrolledWindow();
    	cnt.PackStart(sw, true, true, 0);
    	vbox = null;
    	vbox = new VBox();
    	sw.AddWithViewport(vbox);
    	sw.SizeAllocated += new SizeAllocatedHandler(sw_SizeAllocated); // todo 04.07.2008 sharpdevelop
    }
    
    void CreateGraphicalTable()
    {
    	table1 = new Table(rows, cols, true);
    	table1.ColumnSpacing = table1.RowSpacing = 0;
    	vbox.Add(table1);
    	//vbox.PackStart(table1, false, false, 0);
    }	
    	
    
    void CreateTextualTable(uint rows)
    {
    	table2 = new Table(rows, 1, false);
    	vbox.Add(table2);
    }
    /*
    void Go_Clicked(object o, EventArgs args)
    {
    	ProcessStart.Execute(entry.Text);
    }
    */
    internal void Home()
    {
		CreateContainer("");
		ArrayList al = Dir.GetArrayList();
		cols = rows = NumberControl.Results2NumberRows(al.Count);
    	ArrayList2Cover(al);//, rows, rows);
    	this.ShowAll();
    }
    
    void Init()
    {
		this.Add(cnt);
		// cnt.PackStart(address, false, false, 0);
    	// entry = new Entry();
		// address.PackStart(entry, true, true, 0);
		// Button button = new Button("go");
		// button.Clicked += new EventHandler(Go_Clicked);
		// address.PackStart(button, false, false, 0);
    }
    /*
	int Max()
	{
		int h = (int)sw.Vadjustment.PageSize;
		int w = (int)sw.Hadjustment.PageSize;
		int space = h > w ? w : h;
    	uint parts = cols > rows ? cols : rows;
    	if (parts < 1) parts = 1;
    	int max = (int) ((float)space / (float)parts);
    	return max;
	}
	*/
	void Max()
	{
		if (cols < 1) cols = 1;
		if (rows < 1) rows = 1;
		xmax = (int)((float)sw.Hadjustment.PageSize / (float)cols);
		ymax = (int)((float)sw.Vadjustment.PageSize / (float)rows);
		//int max = (int) ((float)space / (float)parts);
    	//return max;
	}
	
    internal void NoResults()
    {
    	string image = imgNoResult1;
    	if (lastNoResults == true) image = imgNoResult2;
    	lastNoResults = !lastNoResults;
    	ShowImage(false, image);
    }
	
   	internal void ShowImage(bool real, string path)
    {
    	CreateContainer(path);
    	cols = rows = 1;
    	CreateGraphicalTable();
    	ImageButton ib = new ImageButton(false, true, true, xmax, ymax, path);
    	if (real) ib.Name = System.IO.Path.GetDirectoryName(path);
    	table1.Attach(ib, 0, 1, 0, 1, AttachOptions.Expand, AttachOptions.Expand, 0, 0);
    	this.ShowAll();
    }
    
   	void sw_SizeAllocated(object o, SizeAllocatedArgs args) // EventArgs args) // todo 04.07.2008 sharpdevelop
    {
    	Max();
		if (xmax == lastXmax && ymax == lastYmax) return;
    	lastXmax = xmax;
    	lastYmax = ymax;
    	// Console.WriteLine("View.sw_SizeAllocated: " + xmax + "/" + ymax);
    	if (table1 != null)
    	{
    		foreach (ImageButton ib in table1) ib.Update(xmax, ymax);
    	}
    }
    
    void TableAddTextButton(bool cover, ref uint row, Ext.Typen type, string name, string path)
    {
    	table2.Attach(new ButtonPlus(cover, type, name, path), 0, 1, row, row+1, AttachOptions.Fill, AttachOptions.Shrink, 0, 0);
    	row++;
    }
    
    void DisposeChildren()
    {
    	try { foreach (ImageButton o in table1) o.Dispose(); } catch { }
    	try { foreach (ButtonPlus o in table2) o.Dispose(); } catch { }
    }
    
    internal void Update(HistoryItem hi)
    {
    	// Console.WriteLine("View.Update");
    	DisposeChildren();
    	
    	if (hi.cover) UpdateGraphical(hi);
    	else UpdateTextual(hi);
    	ShowAll();
    }
    
    // /a/s/D2004
    // breiter Text, Bilder werden nicht ganz gezeigt
    internal void UpdateFromDirectory(string path)
    {
    menu = Menus.Folder(path, Img.Cover(path));
    	menu.ShowAll();
    	
    	
    	
    	//Console.WriteLine("View.UpdateFromDirectory");
    	try
    	{
	    	CreateContainer(path);
	    	lastPath = path;
    		ArrayList files = InOut.DirectoryFilesSorted(path);
	    	ArrayList dirs = new ArrayList();
	    	if (!Gui.gui.sc.cover.Active) dirs = InOut.DirectoryFoldersSorted(false, path);
	    	else
	    	{
	    		ArrayList al = InOut.DirectoryFoldersSorted(false, path);
	    		ArrayList cover = new ArrayList();
	    		int limit = Gui.gui.sc.Limit;
	    		cols = 0;
		    	rows = 0;
	    		if (al.Count > 0)
	    		{
	    			if (limit == 0) limit = 90;
	    			if (limit > al.Count) limit = al.Count;
		    		NumberControl.Limit2PartScreen(ref limit, ref rows, ref cols);
		    		if (limit > al.Count) limit = al.Count;
		    		for (int i = 0; i < limit; i++) cover.Add(al[i]);
	    			for (int i = limit; i < al.Count; i++) dirs.Add(al[i]);
	    		}
	    		//Console.WriteLine("View.UpdateFromDirectory 10");
	    		ArrayList2Cover(cover);
	    	}
	    	//Console.WriteLine("View.UpdateFromDirectory 20");
	    	CreateTextualTable((uint)(dirs.Count + files.Count));
	    	uint row = 0;
	    	//Console.WriteLine("View.UpdateFromDirectory 30");
	    	foreach (string str in dirs) TableAddTextButton(Gui.gui.sc.cover.Active, ref row, Ext.Typen.folder, Peculiar.Substitute(System.IO.Path.GetFileName(str)), str);
	    	//Console.WriteLine("View.UpdateFromDirectory 40");
	    	foreach (string str in files) TableAddTextButton(false, ref row, Ext.Path2Typ(str), Peculiar.Substitute(System.IO.Path.GetFileName(str)), str);
	    	//Console.WriteLine("View.UpdateFromDirectory 50");
	    	Gui.gui.ShowAlbumImages(path);
	    	//Console.WriteLine("View.UpdateFromDirectory 60");
	    	this.ShowAll();
	    	//Console.WriteLine("View.UpdateFromDirectory exit");
    	} catch (Exception e) { Console.WriteLine(e.Message); }
    }
    
    internal void UpdateFromDirectoryLevelUp()
    {
    	try { UpdateFromDirectory(System.IO.Path.GetDirectoryName(lastPath)); } catch (Exception e) { Console.WriteLine("UpdateFromDirectoryLevelUp: " + e.Message); }
    }
    
    void UpdateGraphical(HistoryItem hi)
    {
    	// Console.WriteLine("View.UpdateGraphical");
    	ArrayList al = new ArrayList();
    	if (hi.fullPath != "") al.Add(hi.fullPath);
    	else al = hi.al;
    	CreateContainer(hi.fullPath);
    	cols = rows = hi.rows;
    	ArrayList2Cover(al);
    	if (hi.fullPath != "") Gui.gui.ShowAlbumImages(hi.fullPath);
    }
    
    void UpdateTextual(HistoryItem hi)
    {
    	// Console.WriteLine("View.UpdateTextual");
    	CreateContainer(hi.fullPath);
    	CreateTextualTable((uint)hi.al.Count);
    	uint row = 0;
    	foreach (string path in hi.al)
    	{
    		Ext.Typen type;
    		string name;
    		if (hi.album) 
    		{
    			Album o = new Album(path);
    			name = o.name;
    			type = Ext.Typen.Album;
    		}
    		else 
    		{
    			Sing o = new Sing(path);
    			name = o.name;
    			type = Ext.Path2Typ(path);// Ext.Typen.audio;
    		}
    		
    		TableAddTextButton(hi.cover, ref row, type, name, path);
    	}
    	if (hi.fullPath != "") Gui.gui.ShowAlbumImages(hi.fullPath);
    	this.ShowAll();
    }
    
    
}

